function [neighbours neighbour_distances] = all_neighbours( distance_matrix, k )
% This returns the indices of the k nearest neighbours of each point
% Arguments: 
%   distance_matrix : N x N matrix of distances (diagonal is zero) 
%   k : small integer >= 1 : number of nearest neighbours of each point to
%       find
% Results: 
%   neighbours : k x N matrix : neighbours( 1:k, n ) is a column vector of
%       the indexes of the k nearest neighbours of point n
%   neighbour_distances : k x N matrix : contains the distances for the
%       corresponding elements in neighbours

[sdmat sdmat_idx] = sort( distance_matrix ); 

neighbours = sdmat_idx( 2:(2+k-1), : )';
neighbour_distances = sdmat( 2:(2+k-1), : )';

end