function draw_labels2( patchspec, category_names, level, thresholds)

if size(patchspec.children,1) == 0, return; end;
fprintf('level: %i Children: %i\n',level,size(patchspec.children,1));
%We paint this level by looking at children of patchspec
%patchspec.children{i} 

string = strcat(category_names(1));

%ignore if xx(1) == xx(2) || yy(1) == yy(2)
if level == 1
    %Plot at bottom
    for i = 1:size(patchspec.children,1)
        string2 = char(strcat(string));
        if i == 1
           string2 = char(strcat(string2,' - Low'));
        elseif i == 2
           string2 = char(strcat(string2,' - Med'));
        else
           string2 = char(strcat(string2,' - High'));
        end
        if patchspec.children{i}.xx(1) == patchspec.children{i}.xx(2) || patchspec.children{i}.yy(1) == patchspec.children{i}.yy(2), continue; end;
        text(mean(patchspec.children{i}.xx),0 - (5-level) * 0.03,string2,'HorizontalAlignment','Center','FontSize',7+(5-level));
    end
elseif level == 2
    t = thresholds(1,level);
    cuts = size(t{1},2) + 1;
    for i = 1:cuts
        string2 = char(strcat(string));
        if i == 1
           string2 = char(strcat(string2,' - Low'));
        elseif i == 2
           string2 = char(strcat(string2,' - Med'));
        else
           string2 = char(strcat(string2,' - High'));
        end
        clear childs;
       childs = patchspec.children(i:cuts:size(patchspec.children,1),1);
       xx = [];
       yy = [];   
       for j = 1:size(childs,1)
           %discard points with no contents
           if not(childs{j}.xx(1) == childs{j}.xx(2) || childs{j}.yy(1) == childs{j}.yy(2))
              xx(size(xx,1)+1,:) = childs{j}.xx;
              yy(size(yy,1)+1,:) = childs{j}.yy;
           end
       end
       warning off all;
       meanx = mean(mean(xx));
       meany = mean(mean(yy));
       warning on all;
       if not(isnan(meanx) || isnan(meany))
          %There is some mass so lets draw labels on left side x = 0 
          % add 0.05 for text size adjustment
           text(0 - (5-level) * 0.03,meany,string2,'HorizontalAlignment','Center','FontSize',7+(5-level));
       end
    end
elseif level == 3
    %keyboard
    t = thresholds(1,level);
    cuts = size(t{1},2) + 1;
    for i = 1:cuts %*cuts
         %childs = patchspec.children(i:cuts:size(patchspec.children,1),1);
         string2 = char(strcat(string));
         if i == 1
           string2 = char(strcat(string2,' - Low'));
        elseif i == 2
           string2 = char(strcat(string2,' - Med'));
        else
           string2 = char(strcat(string2,' - High'));
        end
       for k = 1:cuts    
         childs = patchspec.children((k-1)*(cuts*cuts)+i:cuts:cuts*cuts*k,1);
         xx = [];
         yy = [];   
         for j = 1:size(childs,1)
             %discard points with no contents
             %plot(mean(childs{j}.xx),mean(childs{j}.yy),'Marker','o','Color','r');
             if not(childs{j}.xx(1) == childs{j}.xx(2) || childs{j}.yy(1) == childs{j}.yy(2))
                xx(size(xx,1)+1,:) = childs{j}.xx;
                yy(size(yy,1)+1,:) = childs{j}.yy;
             end
         end
         %warning off;
         warning off all;
         meanx = mean(mean(xx));
         meany = mean(mean(yy));
         
         warning on all;
         if not(isnan(meanx) || isnan(meany))
            %There is some mass so lets draw labels on left side x = 0 
            % add 0.05 for text size adjustment
             text(meanx,1.06 + (5-level) * 0.03,string2,'HorizontalAlignment','Center','FontSize',7+(5-level),'Rotation',90);
         end
       end % k loop
    end % end i loop
elseif level == 4
    t = thresholds(1,level);
    cuts = size(t{1},2) + 1;
    colours = ['k';'g';'b';'r';'c';'y';'m'];
    %keyboard
    %draw Legend
    hold on
    h1 = [];
    for i = 1:cuts
        h1(i,1) = plot(0,0,'Color',colours(i,1));
    end
    %h1 = plot(zeros(cuts,1),zeros(cuts,1),'Color',colours(1:cuts));
    legend(h1,char(strcat(string,' - Low')),char(strcat(string,' - Med')),char(strcat(string,' - High')));
    delete(h1);
    %legend(gca,h1);
    hold off

    
end

%for i = 1:size(patchspec.children,1)
%   


%Call next level
topasson.children = {};
cur = 1;
names_to_pass_on = category_names(1,2:end);
for i = 1:size(patchspec.children,1)
    if size(patchspec.children{i}.children,1) > 0
    topasson.children(cur:cur + size(patchspec.children{i}.children,1) -1,1) = patchspec.children{i}.children;
    cur = cur + size(patchspec.children{i}.children,1);
    end
end

draw_labels2(topasson,names_to_pass_on,level+1,thresholds);

