function draw_patches( patchspec, level, clr )
% level should be a positive integer >= 1 specifying the level
% patchspec is as produced by divide_patches, is a tree of patchspecs

if nargin == 2
    clr = 'k';
end

if level == 0 % draw current patch
    xx = patchspec.xx; 
    yy = patchspec.yy; 
    expanded_xx = [ xx(1); xx(1); xx(2); xx(2) ];
    expanded_yy = [ yy(1); yy(2); yy(2); yy(1) ]; 
    if (xx(1) == xx(2)) || (yy(1) == yy(2))
        return;
    end
    patch( expanded_xx, expanded_yy, clr ); 
    
else
    nc = length( patchspec.children ); 
    colours = ['k','g','b','r','c','y','m'];
    for cx = 1:nc
        draw_patches( patchspec.children{cx}, level - 1, colours( mod(cx-1,length(colours)) + 1 ) ); 
    end
end

