function dmat = euclidean_squared_distances( rowvecs ) 
% returns a square matrix containing the euclidean squared
% distance betwen each pair of rows in rowvecs
% Note that for 0/1 matrices, these are the Hamming distances between
% vectors

sq_lengths = sum( rowvecs .* rowvecs, 2 ); 
dmat = bsxfun( @plus, sq_lengths', ...
    bsxfun( @plus, sq_lengths, ...
    (-2 * rowvecs) * rowvecs' ) );

end