function varargout = gui_analysis(varargin)
% GUI_ANALYSIS M-file for gui_analysis.fig
%      GUI_ANALYSIS, by itself, creates a new GUI_ANALYSIS or raises the existing
%      singleton*.
%
%      H = GUI_ANALYSIS returns the handle to a new GUI_ANALYSIS or the handle to
%      the existing singleton*.
%
%      GUI_ANALYSIS('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GUI_ANALYSIS.M with the given input arguments.
%
%      GUI_ANALYSIS('Property','Value',...) creates a new GUI_ANALYSIS or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before gui_analysis_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to gui_analysis_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES


% Edit the above text to modify the response to help gui_analysis

% Last Modified by GUIDE v2.5 10-Aug-2011 10:34:08

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @gui_analysis_OpeningFcn, ...
                   'gui_OutputFcn',  @gui_analysis_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before gui_analysis is made visible.
function gui_analysis_OpeningFcn(hObject, eventdata, handles, varargin)
% Opening function for the gui, important variables are initalized here.
% This code is executed when it is loaded
handles.output = hObject;
handles.highlighted= [];

% Choose Inital Study -- Code now commented as I don't like it this way.
%[filename, pathname] = uigetfile({'*.mat';'*.*'},'Select a Study file to load','../data/studies/Study.mat');
%if isequal(filename,0) || isequal(pathname,0)
%else
%   evalin('base', strcat('load(''',strcat(pathname,filename),''');'));
%end

%Initalize Tables.
try 
handles.TableCNames = evalin('base','annotation.MiniGoTerms2(1,1:annotation.display)');
catch 
handles.TableCNames = { 'Table'};
end
set(handles.uitable1,'ColumnName',handles.TableCNames);
set(handles.searchMenu,'String','Load Libraries!');

text = 'Load Study'; %evalin('base','Study.ColumnIDs');
set(handles.listbox1,'String',text);
set(handles.listbox2,'String',text);
set(handles.listbox3,'String',text);

eventdata.Indices = [];
handles.supplementries_Loaded = 0;
handles.annotation_loaded = '';
handles.supplementries_loaded = {};
% Update handles structure
guidata(hObject, handles);
%Clear Base Vars
evalin('base','clear LookUpAffy LookUpNum MiniGoTerms2 Study Transcription_Nums Transcription_Table tsneData xselect yselect pointslist mappedX landmarks costs i');

% set Panel visibilites up
set(handles.toolsPanelLoad,'visible','on');
set(handles.toolPanelsTable,'visible','off');
set(handles.toolsPanelColours,'visible','off');
set(handles.toolPanelsNotes,'visible','off');

%Initalize table for colour property selections
    set(handles.colourNonDuplicatesTable,'ColumnEditable', [ false true] );
    set(handles.colourNonDuplicatesTable,'Data',{'Light Green' 'None';'Red' 'None';'Blue' 'None';'Black' 'None';'Orange' 'None';'Yellow' 'None';'Magenta' 'None';'Cyan' 'None';'Grey' 'None'; 'Peach' 'None'});
    set(handles.colourNonDuplicatesTable,'ColumnName',{'Colour' , 'Property'});
    set(handles.colourNonDuplicatesTable,'ColumnWidth',{70, 190});

% --- Outputs from this function are returned to the command line.
function varargout = gui_analysis_OutputFcn(hObject, eventdata, handles) 
varargout{1} = handles.output;


% --- Executes on button press in selectAllPoints.
function selectAllPoints_Callback(hObject, eventdata, handles)
% Select all points will select all the points then add them to the uitable
% so that the user can view the points and use the tools aviable for the
% tablee, like plotting the zscores.
%generate yselect xselect pointslist, then generate the table.
try delete(handles.highlighted);
catch
end

handles.highlighted = [];
handles.data = {};
evalin('base','pointslist = (1:size(tsneData,1))''; xselect = tsneData(:,1); yselect = tsneData(:,2);');

evalin('base','pointsListNums = Study.AffyIDNums(pointslist);');
set(handles.uitable1,'Data',cellstr('Generating Table (1/4) ...'));
pause(0.1);


handles.data(:,1) = evalin('base','LookUpAffy(pointsListNums);');
%evalin('base','geneTitles = MiniGoTerms2(pointsListNums+1,14); geneSymbols = MiniGoTerms2(pointsListNums+1,15);');
annot_cols = evalin('base','annotation.display');
handles.data(:,2:annot_cols) = evalin('base','annotation.MiniGoTerms2(pointsListNums+1,2:annotation.display)');
%handles.data(:,3) = evalin('base','geneSymbols');
set(handles.uitable1,'Data',cellstr('Generating Table (2/4) ...'));
pause(0.1);
% Gather data from transcription file
set(handles.uitable1,'Data',cellstr('Generating Table (3/4) ...'));
pause(0.1);
transSize = 0;
try
if evalin('base','exist(''Transcription_Table'')'),
    transSize = evalin('base','size(Transcription_Table,2)') - 1; %First column is affyIds so skip
    for i = 2:(transSize+1) % loop through columns
        warning off;
        evalin('base',sprintf('temp = cell(size(pointslist),1); for i = 1:size(pointslist,1), for j = 1:size(Transcription_Table,1), if pointsListNums(i) == Transcription_Nums(j), temp(i,1) = Transcription_Table(j,%i); break; end; end; end;',i));
        warning on;
        handles.data(:,annot_cols+(i-1)) = evalin('base','temp');
    end 
end
catch
    disp('Error: You need to preprocess.');
    return;
end

set(handles.uitable1,'Data',cellstr('Generating Table (4/4) ...'));
pause(0.1);
% Throw in raw data acquire from Study file

handles.data(:,(1+annot_cols)+transSize:((1+annot_cols)+transSize+(evalin('base','Study.groups')-1))) = num2cell(evalin('base','Study.data(pointslist,:)'));

% Gather data from Go Terms table

set(handles.uitable1,'Data',handles.data);
set(handles.uitable1,'ColumnWidth',{ 200, 100});
% Columns names are set up at the start
t = handles.TableCNames;
t(1,1) = {sprintf('%s (selected: %i)',char(handles.TableCNames(1,1)),size(handles.data,1))};
set(handles.uitable1,'ColumnName',t);
set(handles.uitable1,'RowName',[]);
guidata(hObject, handles);
disp('Complete');
evalin('base','clear i j temp geneSymbols geneTitles');



% --- Executes on button press in selectButton.
function selectButton_Callback(hObject, eventdata, handles)
% selectButton - this button will initate the selectdata function for
% grabbing points then read the data it returns and use it to form up some
% contents for the uitable
try
delete(handles.highlighted);
catch
end

handles.highlighted = [];
handles.data = {};
evalin('base','clear transcriptionTable');
try
evalin('base','[pointslist,xselect,yselect] = selectdata();');
catch
    disp('Fault: Detected in selection Tool Refreshing plot');
    evalin('base','scatter(tsneData(:,1),tsneData(:,2),8, [ 0 0 0], ''filled'');');
    axis tight off;
    return;
end
if evalin('base','length(pointslist) ~= 0')
try
evalin('base','pointsListNums = Study.AffyIDNums(pointslist);');
catch
    disp('Fault: Detected in selection Tool Refreshing plot');
    evalin('base','scatter(tsneData(:,1),tsneData(:,2),8, [ 0 0 0], ''filled'');');
    axis tight off;
    return;
end

set(handles.uitable1,'Data',cellstr('Generating Table (1/4) ...'));
pause(0.1);


handles.data(:,1) = evalin('base','LookUpAffy(pointsListNums);');
%evalin('base','geneTitles = MiniGoTerms2(pointsListNums+1,14); geneSymbols = MiniGoTerms2(pointsListNums+1,15);');
annot_cols = evalin('base','annotation.display');
handles.data(:,2:annot_cols) = evalin('base','annotation.MiniGoTerms2(pointsListNums+1,2:annotation.display)');
%handles.data(:,3) = evalin('base','geneSymbols');
set(handles.uitable1,'Data',cellstr('Generating Table (2/4) ...'));
pause(0.1);
% Gather data from transcription file
set(handles.uitable1,'Data',cellstr('Generating Table (3/4) ...'));
pause(0.1);
transSize = 0;
try
if evalin('base','exist(''Transcription_Table'')'),
    transSize = evalin('base','size(Transcription_Table,2)') - 1; %First column is affyIds so skip
    for i = 2:(transSize+1) % loop through columns
        warning off;
        evalin('base',sprintf('temp = cell(size(pointslist),1); for i = 1:size(pointslist,1), for j = 1:size(Transcription_Table,1), if pointsListNums(i) == Transcription_Nums(j), temp(i,1) = Transcription_Table(j,%i); break; end; end; end;',i));
        warning on;
        handles.data(:,annot_cols+(i-1)) = evalin('base','temp');
    end 
end
catch
    disp('Error: You need to preprocess.');
    return;
end

set(handles.uitable1,'Data',cellstr('Generating Table (4/4) ...'));
pause(0.1);
% Throw in raw data acquire from Study file

handles.data(:,(1+annot_cols)+transSize:((1+annot_cols)+transSize+(evalin('base','Study.groups')-1))) = num2cell(evalin('base','Study.data(pointslist,:)'));

% Gather data from Go Terms table

set(handles.uitable1,'Data',handles.data);
set(handles.uitable1,'ColumnWidth',{ 200, 100});
% Columns names are set up at the start
t = handles.TableCNames;
t(1,1) = {sprintf('%s (selected: %i)',char(handles.TableCNames(1,1)),size(handles.data,1))};
set(handles.uitable1,'ColumnName',t);
set(handles.uitable1,'RowName',[]);
guidata(hObject, handles);
set(handles.panelSelectionMenu,'Value',2);
panelSelectionMenu_Callback(handles.panelSelectionMenu, eventdata, handles);
disp('Complete');
evalin('base','clear i j temp geneSymbols geneTitles');
end

% HIGHGLIGHHHTTTT with on/off value in the table



%display results in table axis?

% --- Executes on button press in renderButton.
function renderButton_Callback(hObject, eventdata, handles)
%renderButton - is the orginal t-SNE button which will use the fast tsne
%based on z-scores and will then take the data sort it into the correct
%order, so that it can be used correctly with the select tool, and plot the
%scatterplot
set(handles.statusText,'String','Rendering t-SNE plot...');
pause(0.001);
%evalin('base','tsneData = tsne( Study.data_z_scores(1:800,1:3) ,ones(size(Study.data_z_scores(1:800,1:3)),1 ),2, 3,  30 );');
%evalin('base','tsneData = tsne( Study.data_z_scores(:,:) ,ones(size(Study.data_z_scores,1),1 ),2, Study.groups,  30 );');
evalin('base',sprintf('[mappedX,landmarks,costs] = fast_tsne(Study.data_z_scores(:,:) ,2, Study.groups, 1, %i );',str2double(get(handles.perplexityValText,'String'))));

%Data comes back in wrong order however landmarks stores the correct order,
%so we'll put it back like that, this is also the most efficent way to
%reorder it :)
warning off;
evalin('base','tsneData = zeros(size(mappedX),2); for i = 1:size(tsneData,1), tsneData(landmarks(i),:) = mappedX(i,:); end');
warning on;

%Reorgniaze the tsneData by reordering by landmarks



evalin('base','scatter(tsneData(:,1),tsneData(:,2),8, [ 0 0 0], ''filled'');');
evalin('base','axis tight');
evalin('base','axis off');
evalin('base','xselect = []; yselect = []; pointslist = [];');
handles.highlighted= [];
guidata(hObject, handles);
set(handles.statusText,'String','Render complete, you may now manipulate the t-SNE plot');
evalin('base','clear mappedX i');


% --- Executes on button press in loadStudy.
function loadStudy_Callback(hObject, eventdata, handles)
% loadStudy - will open the study, and then with the study initalize the
% uitable, and set the various popupmenus to be concurrent with the study
% as well as then updating the name of the window itself.
[filename, pathname] = uigetfile({'*.mat';'*.*'},'Select a Study file to load','../data/studies/Study.mat');
if isequal(filename,0) || isequal(pathname,0)
else
   set(handles.statusText,'String','Loading Study.');
   pause(0.0001);
   evalin('base', strcat('load(''',strcat(pathname,filename),''');'));
   text = evalin('base','Study.ColumnIDs');
   set(handles.listbox1,'String',text);
   set(handles.listbox2,'String',text);
   set(handles.listbox3,'String',text);
   handles.highlighted= [];
   set(handles.statusText,'String','Study loaded.');
   try
   set(handles.studyNotesText,'String',evalin('base','Study.studyNotes'));
   set(handles.repoNotesText,'String',evalin('base','Study.repoNotes'));
   catch
   end
   try
        f = str2double(evalin('base','Study.Filter_Threshold'));
        g = str2double(evalin('base','Study.Filter_Fscore'));
        s = sprintf('Thresold filter val: %f F-Score Filter: %f',f,g);
        set(handles.studyInfoText,'String',s);
   catch
   end
   set(handles.anaNotesText,'String','<Insert notes>');
   %studyNotesText
   %repoNotesText
   %anaNotesText

end
try
set(handles.figure1,'Name',sprintf('Analysis Tool - Study ( Rep: %s Genes: %i ) Annotation ( Primary - %s Supplementaries Loaded - %i )',evalin('base','Study.name'),evalin('base','size(Study.raw,1)'),handles.annotation_loaded,handles.supplementries_Loaded));
catch
end
guidata(hObject, handles);

% --- Executes when selected cell(s) is changed in uitable1.
function uitable1_CellSelectionCallback(hObject, eventdata, handles)
% uitable1 is the table which contains the data of the 'selected' points,
% this code here is executed when you select elements of the table, it will
% then locate the points you have selected and plot a highlighted spot over
% them.
if (size(eventdata.Indices) > 0)
    try
    delete(handles.highlighted);
    catch
    end
    handles.highlighted = [];
    i = eventdata.Indices(:,1);
    % i = row index of one clicked
    hold on
    %set(flaghandle,'Color',params.FlagColor,'MarkerFaceColor',params.FlagColor)
    %steal xselect values/yselect values from parameters
    xselect = evalin('base','xselect');
    yselect = evalin('base','yselect');
    handles.highlighted = plot(xselect(i),yselect(i),'o');
    set(handles.highlighted,'Color','r');
    hold off
    %delete(handles.highlighted);
    handles.selected = eventdata.Indices;
    guidata(hObject, handles);
end




% --- Executes on button press in colourButton.
function colourButton_Callback(hObject, eventdata, handles)
% colorButton - is the button which will apply colours on the plot based on
% what was selected in the red/green/blue listboxes

redcolumn = get( handles.listbox1, 'Value' ); 
greencolumn = get( handles.listbox2, 'Value'); 
bluecolumn = get( handles.listbox3, 'Value'); 
evalin('base','data_0_to_1 = normalise_from_0_to_1(Study.data_z_scores);');
%Require normalized data
%clrs = handles.alldata.colours( :, [ redcolumn, greencolumn, bluecolumn ] ); 
%handles.current_colours = clrs; 
if get(handles.targetMenu,'Value') == 2
    evalin('base','figure');
end
evalin('base',sprintf('scatter(tsneData(:,1),tsneData(:,2),12, data_0_to_1(:,[ %i %i %i ]), ''filled'');',redcolumn,greencolumn,bluecolumn));
evalin('base','warning off');
evalin('base','axis tight off');

if get(handles.targetMenu,'Value') == 1
    try
        delete(handles.highlighted);
    catch
    end
    handles.highlighted= [];
    guidata(hObject, handles);
elseif get(handles.targetMenu,'Value') == 2
    try
    assignin('base','i',handles.selected(:,1));
    evalin('base','hold on');
    evalin('base','hh = plot(xselect(i),yselect(i),''o'');');
    evalin('base','set(hh,''Color'',''r'');');
    evalin('base','hold off');
    catch
    end
end


% --- Executes on button press in plotSubsetButton.
function plotSubsetButton_Callback(hObject, eventdata, handles)
% plotSubsetButton - plots a line graph of the select elements from the
% table with a legend and colours, based on their Z-Scores

pointsList = evalin('base','pointslist');
pointsList(handles.selected(:,1));
%indexs will match those from the graph, pointslist will match

guidata(hObject, handles);
if not( isempty( handles.selected) )
    rawData = evalin('base','Study.data_z_scores');
    rawData = rawData(unique(pointsList(handles.selected(:,1))),:);
    f1 = figure; % Create a new figure
    set(f1, 'color', 'white'); % White background on the graph
    hold on % ensures all lines stay on the same figure
    % Plot each gene on the figure
    for i = 1:size(rawData,1)
        a = 3.1415*2*(i / size(rawData,1));
        col = [ ((sin(a+(3.14/2))+1)/2) ((sin(a)+1)/2) ((sin(a+3.14)+1)/2) ];
        plot(1:size(rawData,2),rawData(i,:),'Color',col);  
    end
    ids = evalin('base','Study.AffyIDs');
    ids = ids(unique(pointsList(handles.selected(:,1))));
    %ids = {'FOXP1','FOXP2','FOXP2','FOXP2','FOXP2'};
    legend(get(f1,'Children'),ids);
   
    % plot at lowest y value
    % Assemble the conditions/times as a X Label.
    
    xlabels = cell(size(rawData,2));
    for i = 1:size(rawData,2)
        xlabels(i) = evalin('base',sprintf('Study.ColumnIDs(%i)',i));
    end
    hold off % We no longer require to put more plots on the figure.
    title('Z Scores of Subset');
    set(gca, 'Box', 'off' );
    ylabel('Z Values');
    set(gca,'XTick',1:size(rawData,2)); % Ensure that a 'pointer' on the figure edge exists for each condition.
    set(gca,'XTickLabel',xlabels); % Label them

   end



% --- Executes on button press in plotExpression.
function plotExpression_Callback(hObject, eventdata, handles)
% plotExpression - plots the linegraph for select points from the table
% based on their expression with colours and a legend

pointsList = evalin('base','pointslist');
pointsList(handles.selected(:,1));
%indexs will match those from the graph, pointslist will match

guidata(hObject, handles);
if not( isempty( handles.selected) )
    rawData = evalin('base','Study.data');
    rawData = rawData(unique(pointsList(handles.selected(:,1))),:);
    
    f1 = figure; % Create a new figure
    set(f1, 'color', 'white'); % White background on the graph
    hold on % ensures all lines stay on the same figure
    % Plot each gene on the figure
     for i = 1:size(rawData,1)
        a = 3.1415*2*(i / size(rawData,1));
        col = [ ((sin(a+(3.14/2))+1)/2) ((sin(a)+1)/2) ((sin(a+3.14)+1)/2) ];
        plot(1:size(rawData,2),rawData(i,:),'Color',col);
    end
     ids = evalin('base','Study.AffyIDs');
    ids = ids(unique(pointsList(handles.selected(:,1))));
    legend(get(f1,'Children'),ids);
    % plot at lowest y value
    % Assemble the conditions/times as a X Label.
    xlabels = cell(size(rawData,2));
    for i = 1:size(rawData,2)
        xlabels(i) = evalin('base',sprintf('Study.ColumnIDs(%i)',i));
    end
    hold off % We no longer require to put more plots on the figure.
    title('Expression Levels of Subset');
    set(gca, 'Box', 'off' );
    ylabel('Mean Expression');
    set(gca,'XTick',1:size(rawData,2)); % Ensure that a 'pointer' on the figure edge exists for each condition.
    set(gca,'XTickLabel',xlabels); % Label them

   end






% --- Executes on button press in searchButton.
function searchButton_Callback(hObject, eventdata, handles)
% searchButton - searches the annotation/supplementary annotation files for
% what has been specified interms of both the string that the user typed
% and the column they picked to search, it will find them then recreate an
% entry with statuses, specifying if they dont exist, wether they are in
% the study or not etc.
    % Setup some useful variables
    val = get (handles.searchMenu,'Value');
    valstrings = get (handles.searchMenu,'String');
         table = cell(1,4);
         table(1,3) = cellstr('Searching...');
         select = get(handles.searchMenu,'String');
         annot_columns = evalin('base','annotation.MiniGoTerms2(1,1:annotation.display)');
         set(handles.searchTable,'ColumnName',{ annot_columns{:} ,'Status', char(valstrings(val)) });
         set(handles.searchTable,'Data',table);
         clear table;
         pause(0.01);
    string = get(handles.searchText,'String');
    %set(handles.searchTable,'Data',[]);
    assignin('base','string',string);

    % Every search is different, all using the strfind method instead of strcmp
    % Idea is we store a list of AffyIDs into a variable: a
    evalin('base','a = [];');
    evalin('base','d = {};');
    while true % Enter loop so we can use break to return
        if strcmp(valstrings(val),'AffyMetrix ID')
            evalin('base','for i = 1:size(LookUpAffy,1), if size(strfind(upper(char(LookUpAffy(i,1))), upper(char(string))),1) > 0, a(size(a,2) +1) = LookUpNum(i);end; end');
            break;
        end
        % Check aganist transcription Table
            try
                toBreak = 0;
                tCols = evalin('base','Transcription_Table(1,:)');
                for i = 2:size(tCols,2)
                    if strcmp(char(tCols(i)),valstrings(val))
                         evalin('base',sprintf('for i = 2:size(Transcription_Table,1), if size(strfind(upper(char(Transcription_Table(i,%i))), upper(char(string))),1) > 0, a(size(a,2) +1) = Transcription_Nums(i); d(size(d,2) +1) = Transcription_Table(i,%i);end; end',i,i));
                         toBreak = 1;
                         break;
                    end
                end
                if toBreak == 1
                    break;
                end
            catch
            end
        % Search Go Terms/Annotation Fle
        annotateCols = evalin('base','annotation.MiniGoTerms2(1,:)');
        for i = 2:size(annotateCols,2)
           if strcmp(char(annotateCols(i)),valstrings(val))
               evalin('base',sprintf('for i = 2:size(annotation.MiniGoTerms2,1), if size(strfind(upper(char(annotation.MiniGoTerms2(i,%i))), upper(char(string))),1) > 0, a(size(a,2) +1) = LookUpNum(i-1); d(size(d,2) +1) = annotation.MiniGoTerms2(i,%i); end; end',i,i));
               break;
           end
        end
        % Check aganist Affy IDs
        break;
    end
    
     aIDs = evalin('base','a');
     if (size(aIDs,1) == 0), disp('NOT FOUND');
         %Say in table not found
         table = cell(1,4);
         table(1,3) = cellstr('Not Found');
         select = get(handles.searchMenu,'String');
         annot_columns = evalin('base','annotation.MiniGoTerms2(1,1:annotation.display)');
         set(handles.searchTable,'ColumnName',{ annot_columns{:} ,'Status', char(valstrings(val)) });
         set(handles.searchTable,'Data',table);
     else
         table = {}; % intilise data table
         for i = 1:size(aIDs,2) % Loop through Affy IDs
             assignin('base','c',aIDs(i));
             
             evalin('base','b = 0; for i = 1:size(Study.AffyIDNums), if Study.AffyIDNums(i) == c, b = 1; break; end; end');
             b = evalin('base','b');
             % In study or not?
             status = 'Unknown';
             if b == 0, status ='Found, not in study';
             else status = 'Found, in Study'; end;
             % throw into search table
             table(i,1) = evalin('base','LookUpAffy(c)');
             num_of_cols = evalin('base','annotation.display');
             table(i,2:num_of_cols) = evalin('base','annotation.MiniGoTerms2(c+1,2:annotation.display)');
             %table(i,2) = evalin('base','annotation.MiniGoTerms2(c+1,15)');
             table(i,num_of_cols+1) = cellstr(status);
             try
                table(i,num_of_cols+2) = cellstr(evalin('base',sprintf('d(%i)',i)));
             catch
                table(i,num_of_cols+2) = cellstr('---');
             end
         end
          set(handles.searchTable,'Data',table);
          select = get(handles.searchMenu,'String');
          annot_columns = evalin('base','annotation.MiniGoTerms2(1,1:annotation.display)');
          set(handles.searchTable,'ColumnName',{ annot_columns{:} ,'Status', char(valstrings(val)) });
          set(handles.searchTable,'ColumnWidth',{ 200, 80 ,120});
          set(handles.searchTable,'RowName',[]);
          sort_Search_Table(handles);
          evalin('base','clear a b c d i j iA attempted ans');
     end


% --- Executes on button press in clearButton.
function clearButton_Callback(hObject, eventdata, handles)
% clearButton - clears the uitable and removes any highlighted regions
try
    delete(handles.highlighted);
catch
end
evalin('base','xselect = []; yselect = []; pointslist = [];');
handles.highlighted = [];
set(handles.uitable1,'Data',[]);
handles.data = {};
guidata(hObject, handles);



% --- Executes on button press in addbutton.
function addbutton_Callback(hObject, eventdata, handles)
% addbutton - will add what ever has been selected from the searchtable
% into the uitable.
try
delete(handles.highlighted);
catch
end
handles.highlighted = [];
% % list of indexs from table: handles.searchIndices(:,1);
tdata = get(handles.searchTable,'Data'); 
% adata = get(handles.uitable1,'Data');
% starti = size(adata,1) + 1;
% % take affyIDs and calculate number then generate rest of the field
column_of_status = evalin('base','annotation.display');
 for i = 1:size(handles.searchIndices(:,1),1);
     if strcmp(char(tdata(handles.searchIndices(i,1),column_of_status+1)),'Found, in Study')
%     
%     %locate affy num
     AffyString = char(tdata(handles.searchIndices(i,1),1));
     evalin('base',sprintf('aString = ''%s'';',AffyString));
     evalin('base',sprintf('aID = -1; for i = 1:size(LookUpAffy,1), if strcmp(LookUpAffy(i),aString), aID = LookUpNum(i); break; end; end'));

    % add to xselect/yselect to allow highlighting
    evalin('base','ID = -1; for i = 1:size(Study.AffyIDNums,1), if (Study.AffyIDNums(i) == aID), ID = i; break; end; end;');
    
    evalin('base','xselect(size(xselect,1)+1,1) = tsneData(ID,1);');
    evalin('base','yselect(size(yselect,1)+1,1) = tsneData(ID,2);');
    evalin('base','pointslist(size(pointslist,1)+1,1) = ID;');
    
    %starti = starti + 1;
    handles.selected = [];
    end
 end
%keyboard

handles.data = {};

%Acquire Affy IDs

evalin('base','pointsListNums = Study.AffyIDNums(pointslist);');
pointNums = evalin('base','pointsListNums');
if (size(pointNums) > 0)
    handles.data(:,1) = evalin('base','LookUpAffy(pointsListNums);');
    %transcriptionTable = { [] }; 
    %evalin('base','geneTitles = cell(size(pointslist)); geneSymbols= cell(size(pointslist)); for i = 1:size(pointslist,1), for j = 1:size(MiniGoTerms2,1), if strcmp(pointsListAffyIDs(i,1),cellstr(MiniGoTerms2(j,1))), geneTitles(i,1) = cellstr(MiniGoTerms2(j,14)); geneSymbols(i,1) = cellstr(MiniGoTerms2(j,15)); i, break; end; end; end;');
    % +1 as MiniGoTerms Table has column titles
    annot_cols = evalin('base','annotation.display');
    handles.data(:,2:annot_cols) = evalin('base','annotation.MiniGoTerms2(pointsListNums+1,2:annotation.display)');
    %handles.data(:,3) = evalin('base','geneSymbols');
    set(handles.uitable1,'Data',cellstr('Generating Table (2/4) ...'));
    pause(0.1);
    % Gather data from transcription file
    transSize = 0;
    try
    if evalin('base','exist(''Transcription_Table'')'),
        transSize = evalin('base','size(Transcription_Table,2)') - 1; %First column is affyIds so skip
        for i = 2:(transSize+1) % loop through columns
            warning off;
            evalin('base',sprintf('temp = cell(size(pointslist),1); for i = 1:size(pointslist,1), for j = 1:size(Transcription_Table,1), if pointsListNums(i) == Transcription_Nums(j), temp(i,1) = Transcription_Table(j,%i); break; end; end; end;',i));
            warning on;
            handles.data(:,annot_cols+(i-1)) = evalin('base','temp');
        end 
    end
    catch
        disp('Error: You need to preprocess.');
        return;
    end


    % Throw in raw data acquire from Study file

    handles.data(:,(1+annot_cols)+transSize:((1+annot_cols)+transSize+(evalin('base','Study.groups')-1))) = num2cell(evalin('base','Study.data(pointslist,:)'));

    % Gather data from Go Terms table

    %handles.data(2:1) = evalin('base','pointsListAffyIDs');

    %handles.data(2:1) = evalin('base','pointsListAffyIDs');
    set(handles.uitable1,'Data',handles.data);
    set(handles.uitable1,'ColumnWidth',{ 200, 100});
    % Columns names are set up at the start
    t = handles.TableCNames;
    t(1,1) = {sprintf('%s (selected: %i)',char(handles.TableCNames(1,1)),size(handles.data,1))};
    set(handles.uitable1,'ColumnName',t);
    set(handles.uitable1,'RowName',[]);

end
guidata(hObject, handles);
disp('Complete');


% --- Executes when selected cell(s) is changed in searchTable.
function searchTable_CellSelectionCallback(hObject, eventdata, handles)
% searchTable_CellSelectionCallback - this simply updates a variable that
% stores which points have been selected so that we can use them for when
% the user clicks the addbutton
handles.searchIndices = unique(eventdata.Indices(:,1));
guidata(hObject, handles);


% --- Executes on button press in exportButton.
function exportButton_Callback(hObject, eventdata, handles)
% exportButton, this will export the uitable it will take everything in the
% uitable not just the selected points and export them into a .csv with all
% the annotation and summplentry annoation for each affyID as well as the
% group means for that affyID
if (not(exist(strcat('../data/studies/',evalin('base','Study.name'),'/Table Exports(.CSVs)'))));
mkdir(strcat('../data/studies/',evalin('base','Study.name'),'/'),'Table Exports(.CSVs)');
end
[filename, pathname] = uiputfile('*.csv','Save Table',strcat('../data/studies/',evalin('base','Study.name'),'/Table Exports(.CSVs)/',evalin('base','Study.name'),'-',num2str(evalin('base','size(Study.data,1)')),'Genes-Exported-Table.csv'));
if isequal(filename,0) || isequal(pathname,0)
else
       %Insert data on a column by column basis.
    %Column headers required too
    
    % First Affy IDs
    goTerms = evalin('base','MiniGoTerms2');
    transcriptionSize = 0;
    try
    transcriptionSize = evalin('base','size(Transcription_Table,2) - 1');
    catch
    end
    points = evalin('base','pointsListNums'); 
    data = cell(size(points,1)+1, size(goTerms,2)-1 + transcriptionSize + 1);
    LookUpAffy = evalin('base','LookUpAffy');
    curCol = 1;
    data(1,1) = cellstr('AffyMetrix ID');
    data(2:end,curCol) = LookUpAffy(points);
    curCol = curCol + 1;
    %copy in Transcription
    try
    %data(:,2:size)
    %headers
    %data(1,curCol:curColtranscriptionSize) =
    tTable = evalin('base','Transcription_Table');
    tNums = evalin('base','Transcription_Nums');
    data(1,curCol:curCol + transcriptionSize -1) = tTable(1,2:2+(transcriptionSize-1));
    % Contents
    % Where POINT LIST NUMS = TRANSCRIPTION _ NUMS
    for i = 1:size(points,1)
        for j = 1:size(tNums,1)
            if points(i) == tNums(j)
                   data(i+1,curCol:curCol + transcriptionSize -1) = tTable(j,2:end);
                break;
            end
        end
    end
    curCol = curCol + transcriptionSize;
    catch
    end
    % MiniGoTerms2
    data(1,curCol:curCol + size(goTerms,2)-2) = goTerms(1,2:end);
    data(2:end,curCol:curCol + size(goTerms,2)-2) = goTerms(points+1,2:end);
    curCol = curCol + size(goTerms,2)-1;
    %Insert raw scores
    pointslist = evalin('base','pointslist');
    groupMeans = evalin('base','Study.data');
    groupMeans = groupMeans(pointslist,:);
    data(2:end,curCol:curCol + size(groupMeans,2)-1) = num2cell(groupMeans);
    cHeaders = evalin('base','Study.ColumnIDs');
    for i = 1:size(cHeaders,2)
        cHeaders(i) = strcat(cHeaders(i),' Mean Expression');
    end
    data(1,curCol:curCol + size(groupMeans,2)-1) = cHeaders;
    %save off data
    f = fopen(sprintf('%s%s',pathname,filename),'w');
    for i = 1:size(data,1)
        % loop through columns now
        for j = 1:size(data,2)
            if not(j == 1), fprintf(f,','); end;
            try
            fprintf(f,'"%s"',char(data(i,j)));
            catch
                try 
                    fprintf(f,'"%f"',cell2mat(data(i,j)));
                catch
                    fprintf(f,'---');
                end
                
            end
        end
        fprintf(f,'\n');
    end
    fclose(f);
end%ask for place to save



% --- Executes on button press in removeButton.
function removeButton_Callback(hObject, eventdata, handles)
% removeButton - removes selected entries from the uitable, and updates the
% table.
try
    delete(handles.highlighted);
catch
end
handles.highlighted = [];
%keyboard
% find and remove
pointsList = evalin('base','pointslist');
xselect = evalin('base','xselect');
yselect = evalin('base','yselect');
toRemoveList = unique(pointsList(handles.selected(:,1)));
newPointsList = [];
newXselect = [];
newYselect = [];
curI = 1;
for i = 1:size(pointsList,1) 
    carryfoward = 1;
    for j = 1:size(toRemoveList,1)
        if pointsList(i) == toRemoveList(j)
            carryfoward = 0;
        end
    end
    if carryfoward == 1
        newXselect(curI,1) = xselect(i);
        newYselect(curI,1) = yselect(i);
        newPointsList(curI,1) = pointsList(i);
        curI = curI + 1;
    end
end
%transfer variables back to base
assignin('base','xselect',newXselect);
assignin('base','yselect',newYselect);
assignin('base','pointslist',newPointsList);

%now remove pointsList from table
%xselect yselect, and pointslist, variables be updated.
handles.data = {};
if (size(newPointsList,1) > 0)
    evalin('base','pointsListNums = Study.AffyIDNums(pointslist);');

    handles.data(:,1) = evalin('base','LookUpAffy(pointsListNums);');
    %evalin('base','geneTitles = MiniGoTerms2(pointsListNums+1,14); geneSymbols = MiniGoTerms2(pointsListNums+1,15);');
    annot_cols = evalin('base','annotation.display');
    handles.data(:,2:annot_cols) = evalin('base','annotation.MiniGoTerms2(pointsListNums+1,2:annotation.display)');
    %handles.data(:,3) = evalin('base','geneSymbols');
    set(handles.uitable1,'Data',cellstr('Generating Table (2/4) ...'));
    pause(0.1);
    % Gather data from transcription file
    set(handles.uitable1,'Data',cellstr('Generating Table (3/4) ...'));
    pause(0.1);
    transSize = 0;
    try
    if evalin('base','exist(''Transcription_Table'')'),
        transSize = evalin('base','size(Transcription_Table,2)') - 1; %First column is affyIds so skip
        for i = 2:(transSize+1) % loop through columns
            warning off;
            evalin('base',sprintf('temp = cell(size(pointslist),1); for i = 1:size(pointslist,1), for j = 1:size(Transcription_Table,1), if pointsListNums(i) == Transcription_Nums(j), temp(i,1) = Transcription_Table(j,%i); break; end; end; end;',i));
            warning on;
            handles.data(:,annot_cols+(i-1)) = evalin('base','temp');
        end 
    end
    catch
        disp('Error: You need to preprocess.');
        return;
    end
end
% Gather data from Go Terms table

set(handles.uitable1,'Data',handles.data);
handles.selected = [];
set(handles.uitable1,'ColumnWidth',{ 200, 100});
% Columns names are set up at the start
t = handles.TableCNames;
t(1,1) = {sprintf('%s (selected: %i)',char(handles.TableCNames(1,1)),size(handles.data,1))};
set(handles.uitable1,'ColumnName',t);
set(handles.uitable1,'RowName',[]);
guidata(hObject, handles);



% --- Executes on button press in loadGoTerms.
function loadGoTerms_Callback(hObject, eventdata, handles)
% loadGoTerms - This loads the primary annotation file
% It will then update all the menus that use the column headers from the
% annotation, as well as update the title of the anaylsis tool window.
[filename, pathname] = uigetfile({'*.mat';'*.*'},'Select a Go Terms file to load','../data/libraries/MiniGoTerms2.mat');
if isequal(filename,0) || isequal(pathname,0)
else
   handles.annotation_loaded = filename;
   set(handles.statusText,'String','Loading annotation...');
   pause(0.0001);
   evalin('base', strcat('load(''',strcat(pathname,filename),''');'));
   listHeaders = {'AffyMetrix ID'};
   annotateHeader = evalin('base','annotation.MiniGoTerms2(1,2:end)');
   curCol = 2;
   % If transcription exists add here
   try
       transcriptHeaders = evalin('base','Transcription_Table(1,2:end)');
       listHeaders(1,curCol:(curCol-1)+size(transcriptHeaders,2)) = transcriptHeaders;
       curCol = curCol + size(transcriptHeaders,2);
   catch
   end
   % Place annotaiton file columns
   listHeaders(1,curCol:(curCol-1)+size(annotateHeader,2)) = annotateHeader;
   
   
   set(handles.searchMenu,'String',listHeaders);
   h(1,1) = cellstr('None');
   h(1,2:size(listHeaders,2)) = listHeaders(1,2:end);
   set(handles.prop1,'String',h); % ignore AffyMetrix ID
   set(handles.prop2,'String',h); % ignore AffyMetrix ID
   set(handles.prop3,'String',h); % ignore AffyMetrix ID
   set(handles.prop4,'String',h); % ignore AffyMetrix ID
   
   %Update non Duplicates Table
    sstring = 'set(handles.colourNonDuplicatesTable,''ColumnFormat'',{''char'',{ ';
    for i = 1:size(h,2)
        sstring = sprintf('%s''%s'' ',sstring,char(h(1,i)));
    end
    sstring = strcat(sstring,'}});');
    eval(sstring);
    
   set(handles.statusText,'String','Primary annotation loaded.');
   try
   set(handles.figure1,'Name',sprintf('Analysis Tool - Study ( Rep: %s Genes: %i ) Annotation ( Primary - %s Supplementaries Loaded - %i )',evalin('base','Study.name'),evalin('base','size(Study.raw,1)'),handles.annotation_loaded,handles.supplementries_Loaded));
   catch
   end
    try 
    handles.TableCNames = evalin('base','annotation.MiniGoTerms2(1,1:annotation.display)');
    catch 
    handles.TableCNames = { 'Table'};
    end
    %acquire column headers
    try
    theaders = evalin('base','Transcription_Table(1,2:end)');
    handles.TableCNames(1,size(handles.TableCNames,2)+1:size(handles.TableCNames,2)+size(theaders,2)) = theaders;
    catch % do nothing should transcription not exist
    end
    mheaders = evalin('base','Study.ColumnIDs');
    handles.TableCNames(1,size(handles.TableCNames,2)+1:size(handles.TableCNames,2)+size(mheaders,2)) = mheaders;
 
   
   guidata(hObject, handles);
end

% --- Executes on button press in loadTranscription.
function loadTranscription_Callback(hObject, eventdata, handles)
% loadTranscription - this loads supplementary annotation files, it will
% deal with the case in which a pre-existing supplementary annotation file
% doesn't exist and it will also deal with the case in which it does, it
% supports precompilied supplementary annotation files or .csv lists, for
% which it creates a new T/F column
tableExist = evalin('base','exist(''Transcription_Table'',''var'')'); % Does table already exist
if tableExist == 0 % If table doesn't already exist
    [filename, pathname] = uigetfile({'*.mat';'*.csv';'*.*'},'Select a supplementary file to load','../data/libraries/Transcript_Tables.mat');
    if isequal(filename,0) || isequal(pathname,0)
    else
       set(handles.statusText,'String','Loading supplementary annotation...');
       pause(0.0001);
       if strfind(filename,'.mat')
           evalin('base', strcat('load(''',strcat(pathname,filename),''');'));
       else % assuming .csv
           t = parseCsvFile(filename,pathname);
           %Expected format entire first column = AffyIDs % Create new

           % 1st Column - Affy IDs
           TT = cell(size(t,1)+1,2);
           TT(1,1) = {'AffyMetrix IDs'}; %Not required as never read by why not?
           TT(2:end,1) = t(:,1);
           % 2nd Column - All True for lest
           TT(1,2) = {sprintf('List - %s',filename)};
           for i = 2:size(TT,1),TT(i,2) = {1}; end;
           assignin('base','Transcription_Table',TT);
       end
       handles.supplementries_Loaded = handles.supplementries_Loaded + 1;
       handles.supplementries_loaded(1,size(handles.supplementries_loaded,2)+1) = cellstr(filename);
    end % end File Exists
else % able Already Exists
    %Transcription_Table Alread Existed
    [filename, pathname] = uigetfile({'*.mat';'*.csv';'*.*'},'Select a Transcription file to load','../data/libraries/Transcript_Tables.mat');
    if isequal(filename,0) || isequal(pathname,0)
    else
       set(handles.statusText,'String','Loading supplementary annotation...');
       pause(0.0001);
       if strfind(filename,'.mat')
           set(handles.statusText,'String','Loading supplementary annotation...');
           pause(0.0001);
           eval(strcat('load(''',strcat(pathname,filename),''');'));
       else % assuming .csv
           t = parseCsvFile(filename,pathname);
           %Expected format entire first column = AffyIDs % Create new
           % 1st Column - Affy IDs
           TT = cell(size(t,1)+1,2);
           TT(1,1) = {'AffyMetrix IDs'}; %Not required as never read by why not?
           TT(2:end,1) = t(:,1);
           % 2nd Column - All True for lest
           TT(1,2) = {sprintf('List - %s',filename)};
           for i = 2:size(TT,1),TT(i,2) = cellstr('1'); end;
           Transcription_Table = TT;
       end
       TT = Transcription_Table;
       tt = evalin('base','Transcription_Table');
       %tt = orginal, TT = new
       
       %add extra columns first
       orgSize = size(tt,2);
       newCcount = size(tt,2)+(size(TT,2)-1);
       tt(:,orgSize+1:newCcount) = cell(size(tt,1),(size(TT,2)-1));
       % give column Titles
       tt(1,orgSize+1:newCcount) = TT(1,2:end);
       
       % Now loop through add entries or mark as true if found
       % Cyclic searching.
       iA = 1;
       for i = 2:size(TT,1)
           attempted = 1;
           while true
             if attempted > size(tt,1)
                 row = size(tt,1)+1;
                 tt(row,1) = TT(i,1);
                 tt(row,orgSize+1:newCcount) = TT(i,2:end);
                % Create new entry
                 break;
             end
             try
                 if strcmp(char(TT(i,1)),char(tt(iA,1)))
                     %Add info
                     tt(iA,orgSize+1:newCcount) = TT(i,2:end);
                     break;
                 end
             catch
             end
             attempted = attempted + 1;
             iA = iA + 1;
             if iA > size(tt,1)
                 iA = 1;
             end;
           end
       end
       %Transcription_Table = tt;
       assignin('base','Transcription_Table',tt);
       handles.supplementries_Loaded = handles.supplementries_Loaded + 1;
       handles.supplementries_loaded(1,size(handles.supplementries_loaded,2)+1) = cellstr(filename);
       %Add onto tt
       
    end % end File Exists
end

% Save if all off/ do Changes
try
    % Update Search/colourize selection drop down menus.
    listHeaders = evalin('base','MiniGoTerms2(1,1)');%{'AffyMetrix ID'};
    curCol = 2;
    % If transcription exists add here
    try
       transcriptHeaders = evalin('base','Transcription_Table(1,2:end)');
       listHeaders(1,curCol:(curCol-1)+size(transcriptHeaders,2)) = transcriptHeaders;
       curCol = curCol + size(transcriptHeaders,2);
    catch
    end
    % Place annotaiton file columns
    try
       annotateHeader = evalin('base','MiniGoTerms2(1,2:end)');
       listHeaders(1,curCol:(curCol-1)+size(annotateHeader,2)) = annotateHeader;
    catch
    end
    % Organize rows by alphabetical order
    try
    evalin('base','[ a newi ]  = sort(Transcription_Table(2:end,1)); clear a;');
    evalin('base','Transcription_Table(2:end,:) = Transcription_Table(newi+1,:); clear newi;');
    catch
    end
  
    
    h(1,1) = cellstr('None');
    h(1,2:size(listHeaders,2)) = listHeaders(1,2:end);
    set(handles.prop1,'String',h); % ignore AffyMetrix ID
    set(handles.prop2,'String',h); % ignore AffyMetrix ID
    set(handles.prop3,'String',h); % ignore AffyMetrix ID
    set(handles.prop4,'String',h); % ignore AffyMetrix ID
    %Update non Duplicates Table
    sstring = 'set(handles.colourNonDuplicatesTable,''ColumnFormat'',{''char'',{ ';
    for i = 1:size(h,2)
        sstring = sprintf('%s''%s'' ',sstring,char(h(1,i)));
    end
    sstring = strcat(sstring,'}});');
    eval(sstring);
    %
    set(handles.searchMenu,'String',listHeaders);
    set(handles.statusText,'String','Supplementary annotation loaded');
    pause(0.0001);
    try 
    handles.TableCNames = evalin('base','annotation.MiniGoTerms2(1,1:annotation.display)');
    catch 
    handles.TableCNames = { 'Table'};
    end
    %acquire column headers
    theaders = evalin('base','Transcription_Table(1,2:end)');
    handles.TableCNames(1,size(handles.TableCNames,2)+1:size(handles.TableCNames,2)+size(theaders,2)) = theaders;
    mheaders = evalin('base','Study.ColumnIDs');
    handles.TableCNames(1,size(handles.TableCNames,2)+1:size(handles.TableCNames,2)+size(mheaders,2)) = mheaders;
    set(handles.figure1,'Name',sprintf('Analysis Tool - Study ( Rep: %s Genes: %i ) Annotation ( Primary - %s Supplementaries Loaded - %i )',evalin('base','Study.name'),evalin('base','size(Study.raw,1)'),handles.annotation_loaded,handles.supplementries_Loaded));

    guidata(hObject, handles);
catch
end


% --- Executes on button press in preprocessButton.
function preprocessButton_Callback(hObject, eventdata, handles)
% preprocessButton - this button will process the annotation files and the
% study data, and 'synch' then to the primary annotation so that they can
% quickly access other as comparing numbers is much faster tahn comparing
% strings, 
set(handles.statusText,'String','Preprocessing... (1/3) Creating index from annotation.');
pause(0.001);
evalin('base','clear LookUpNum LookUpAffy;');
evalin('base','LookUpNum(:,1) = 1:(size(annotation.MiniGoTerms2,1)-1); LookUpAffy(:,1) = annotation.MiniGoTerms2(2:end,1);');
% Give Transcription_Table - Column with number
% Loop through rows start at 2 to skip the header
% iA = 1 ; %index on teh next loop
% Transcription_Nums = zeros(size(Transcription_Table,1),1);
% for i = 2:size(Transcription_Table,1)
%      if (mod(i,100) == 0)
%         fprintf('Counted %i of %i ...\n',i,size(Transcription_Table,1));
%      end
%     attempted = 1;
%     while true
%         if attempted > size(LookUpAffy,1)*2
%             Transcription_Nums(i,1) = -1;
%             break;
%         end
%         if strcmp(Transcription_Table(i,1),LookUpAffy(iA,1))
%             Transcription_Nums(i,1) = iA;
%             break;
%         end
%         attempted = attempted + 1;
%         iA = iA + 1;
%         if iA > size(LookUpAffy,1)
%             iA = 1;
%         end;
%     end
% end
set(handles.statusText,'String','Preprocessing... (2/3) Indexing supplementary table');
pause(0.001);
try %Preprocess if exists
    %LookUpAffy = evalin('base','LookUpAffy');
    %Transcription_Table = evalin('base','Transcription_Table');
    
    
   % [new newi] = sort(Transcription_Table(2:end,1));
   % Transcription_Table(2:end,:) = Transcription_Table(newi+1,:);
    
    
    evalin('base','iA = 1 ; Transcription_Nums = zeros(size(Transcription_Table,1),1);');
    evalin('base','for i = 2:size(Transcription_Table,1),attempted = 1;  while true, if attempted > size(LookUpAffy,1)*2, Transcription_Nums(i,1) = -1; break; end; if strcmp(Transcription_Table(i,1),LookUpAffy(iA,1)),Transcription_Nums(i,1) = iA; break; end; attempted = attempted + 1; iA = iA + 1; if iA > size(LookUpAffy,1), iA = 1; end; end; end;');
%     iA = 1 ; Transcription_Nums = zeros(size(Transcription_Table,1),1);
%     for i = 2:size(Transcription_Table,1),attempted = 1;  
%         while true, 
%             if attempted > size(LookUpAffy,1)*2, Transcription_Nums(i,1) = -1; 
%                 break; 
%             end; 
%             if strcmp(Transcription_Table(i,1),LookUpAffy(iA,1)),Transcription_Nums(i,1) = iA; 
%                 break; 
%             end; 
%             attempted = attempted + 1; 
%             iA = iA + 1; 
%             if iA > size(LookUpAffy,1), 
%                 iA = 1; 
%             end; 
%         end; 
%     end;
%     assignin('base','Transcription_Nums',Transcription_Nums);
catch
end
%% Study Generate Nums
evalin('base','Study.AffyIDNums = zeros(size(Study.data,1),1); '); %index on teh next loop


set(handles.statusText,'String','Preprocessing... (3/3) Indexing genes');
pause(0.001);



evalin('base','iA = 1 ; for i = 1:size(Study.data,1),;attempted = 1;while true,if attempted > size(LookUpAffy,1)*2,Study.AffyIDNums(i,1) = -1;break;end;if strcmp(Study.AffyIDs(i,1),LookUpAffy(iA,1)),Study.AffyIDNums(i,1) = iA;break;end;attempted = attempted + 1;iA = iA + 1;if iA > size(LookUpAffy,1),iA = 1;end;end;end;');

set(handles.statusText,'String','Preprocessing complete.');

evalin('base','clear iA i attempted');





% --- Executes on button press in exporttsneButton.
function exporttsneButton_Callback(hObject, eventdata, handles)
%exporttsneButton - this exports the tsneData alongside the study variable
%into a container that contains both.

%Objects we wish to save.
container.Study = evalin('base','Study');
container.tsneData = evalin('base','tsneData');
container.landmarks = evalin('base','landmarks');
container.costs = evalin('base','costs');
container.Study.anaNotes = get(handles.anaNotesText,'String');

if (not(exist(strcat('../data/studies/',container.Study.name))))
mkdir('../data/studies/',container.Study.name);
end
[filename, pathname] = uiputfile('*.mat','Save Study with t-SNE',strcat('../data/studies/',container.Study.name,'/',container.Study.name,'-',num2str(size(container.Study.data,1)),'Genes-Exported-tSNE-Study.mat'));
if isequal(filename,0) || isequal(pathname,0)
     % Error expected if folder has contents, this was only added to
     % remove, blank folders
     try
    rmdir(strcat('../data/studies/',container.Study.name));
    catch
    end
else
   %save(sprintf('%s%s',pathname,filename),'-struct','handles','Study');
   save(sprintf('%s%s',pathname,filename),'container');
end



% clear up
clear container;

% --- Executes on button press in importtsneButton.
function importtsneButton_Callback(hObject, eventdata, handles)
%importtsneButton - this is for importing exported tsne data, it will open
%it and 'unpack' the container file.
% Choose Inital Study

[filename, pathname] = uigetfile({'*.mat';'*.*'},'Select a Study with t-SNE file to load','../data/studies/Study.mat');
if isequal(filename,0) || isequal(pathname,0)
else
    set(handles.statusText,'String','Importing pre-rendered files...');
   evalin('base', strcat('load(''',strcat(pathname,filename),''');'));
   evalin('base','Study = container.Study;');
   evalin('base','tsneData = container.tsneData;');
   set(handles.anaNotesText,'String','<Insert notes here>');
   try
   evalin('base','landmarks = container.landmarks;');
   evalin('base','costs = container.costs;');
   set(handles.anaNotesText,'String',evalin('base','Study.anaNotes'));
   catch
   end
   try
        f = str2double(evalin('base','Study.Filter_Threshold'));
        g = str2double(evalin('base','Study.Filter_Fscore'));
        s = sprintf('Thresold filter val: %f F-Score Filter: %f',f,g);
        set(handles.studyInfoText,'String',s);
   catch
   end

   evalin('base','clear container');
   set(handles.figure1,'Name',sprintf('Analysis Tool - Study ( Rep: %s Genes: %i ) Annotation ( Primary - %s Supplementaries Loaded - %i )',evalin('base','Study.name'),evalin('base','size(Study.raw,1)'),handles.annotation_loaded,handles.supplementries_Loaded));

text = evalin('base','Study.ColumnIDs');
set(handles.listbox1,'String',text);
set(handles.listbox2,'String',text);
set(handles.listbox3,'String',text);

eventdata.Indices = [];
% Reprocess
try
set(handles.studyNotesText,'String',evalin('base','Study.studyNotes'));
set(handles.repoNotesText,'String',evalin('base','Study.repoNotes'));
catch
end
preprocessButton_Callback(hObject, eventdata, handles);
set(handles.statusText,'String','Rendered. You may now manipulate the t-SNE plot.');
evalin('base','xselect = []; yselect = []; pointslist = [];');

% Replot tsne

handles.highlighted= [];
evalin('base','hold off');
evalin('base','scatter(tsneData(:,1),tsneData(:,2),8, [ 0 0 0], ''filled'');');
evalin('base','axis tight');
evalin('base','axis off');
end


% --- Executes on button press in plotZNoColoursButton.
function plotZNoColoursButton_Callback(hObject, eventdata, handles)
%plotZNoColoursButton - plots the z scores for the select rows on the
%uitable without colours useful for large amounts of rows.
pointsList = evalin('base','pointslist');
pointsList(handles.selected(:,1));
%indexs will match those from the graph, pointslist will match

guidata(hObject, handles);
if not( isempty( handles.selected) )
    rawData = evalin('base','Study.data_z_scores');
    rawData = rawData(unique(pointsList(handles.selected(:,1))),:);
    f1 = figure; % Create a new figure
    set(f1, 'color', 'white'); % White background on the graph
    hold on % ensures all lines stay on the same figure
    % Plot each gene on the figure
    for i = 1:size(rawData,1)
      
        plot(1:size(rawData,2),rawData(i,:));  
    end   
    % plot at lowest y value
    % Assemble the conditions/times as a X Label.
    xlabels = cell(size(rawData,2));
    for i = 1:size(rawData,2)
        xlabels(i) = evalin('base',sprintf('Study.ColumnIDs(%i)',i));
    end
    hold off % We no longer require to put more plots on the figure.
    title('Z Scores of Subset');
    set(gca, 'Box', 'off' );
    ylabel('Z Values');
    %CRASHES IT ON XTICK
    set(gca,'XTick',1:size(rawData,2)); % Ensure that a 'pointer' on the figure e dge exists for each condition.
    set(gca,'XTickLabel',xlabels); % Label them

   end

% --- Executes on button press in plotExpressionNoColoursButton.
function plotExpressionNoColoursButton_Callback(hObject, eventdata, handles)
%plotExpressionNoColoursButton - this takes the select points from the
%uitable and will then plot their expression levels aganist the conditions,
%without any colours (aka all blue)
pointsList = evalin('base','pointslist');
pointsList(handles.selected(:,1));
%indexs will match those from the graph, pointslist will match

guidata(hObject, handles);
if not( isempty( handles.selected) )
    rawData = evalin('base','Study.data');
    rawData = rawData(unique(pointsList(handles.selected(:,1))),:);
    
    f1 = figure; % Create a new figure
    set(f1, 'color', 'white'); % White background on the graph
    hold on % ensures all lines stay on the same figure
    % Plot each gene on the figure
     for i = 1:size(rawData,1)
        plot(1:size(rawData,2),rawData(i,:));
     end
    % plot at lowest y value
    % Assemble the conditions/times as a X Label.
    xlabels = cell(size(rawData,2));
    for i = 1:size(rawData,2)
        xlabels(i) = evalin('base',sprintf('Study.ColumnIDs(%i)',i));
    end
    hold off % We no longer require to put more plots on the figure.
    title('Expression Levels of Subset');
    set(gca, 'Box', 'off' );
    ylabel('Mean Expression');
    set(gca,'XTick',1:size(rawData,2)); % Ensure that a 'pointer' on the figure edge exists for each condition.
    set(gca,'XTickLabel',xlabels); % Label them

   end


% --- Executes on button press in mosaicButton.
function mosiacButton_Callback(hObject, eventdata, handles)
%mosaicButton Launchs the mosaic plot window
gui_mosaic

%construct_mosaic_plot(Study.data,{'a','b','c','d'},{{5,6},{6,7},{7,8},{9,10}});


% --- Executes on button press in importListButton.
function importListButton_Callback(hObject, eventdata, handles)
%importListButton - imports a list and acquires the AffyIds from it and
%dumps them into the searchtable along with their statuses.
[filename, pathname] = uigetfile({'*.csv';'*.txt';'*.*'},'Select Normalized Raw Data file (in .CSV format) to load','../data/studies/raw.txt');
if isequal(filename,0) || isequal(pathname,0)
else
 fid = fopen(strcat(pathname,filename));
  % number of columns/split
  %C = textscan(fid, '%s %s %s','delimiter', ',');
  lineCount = 1;
  tline = fgetl(fid);
  %Initially we are determing the size
  % The code looks somewhat complex to the fact that csv format also has a
  % clause that if a comma exists inside a cell it then puts "s around
  % the cell, and this needs to be taken into account in both counting
  % columns and the actualy processing
  %First count how columns are in the first line
    requiredColumns = 0;
    remaining = tline;
    across = 1;
    ignoring = 0;
    while(size(remaining,2) > 1)           
        for j = 1:(size(remaining,2))
            if ignoring == 1
                if strcmp(remaining(j),'"')
                    if j+1 < (size(remaining,2))
                        if strcmp(remaining(j+1),','), ignoring = 0; end;
                    end
                end
            else
                if j == 1 && strcmp(remaining(1),'"')
                   ignoring = 1; 
                end
                if strcmp(remaining(j),',')
                    if strcmp(remaining(j+1),'"'),ignoring = 1; end;
                    requiredColumns = requiredColumns + 1;
                    remaining = remaining((j + 1):end);
                    across = across + 1;
                    break;
                end 
            end
            if j == size(remaining,2)
               %copy this off
                requiredColumns = requiredColumns + 1;
               remaining = '';
            end
            %j = j +1;
        end
    end
  
  lineCount = 1; % Line count starts as one as we just parsed the column count from the first row.
    while ischar(tline),lineCount = lineCount +1; tline = fgetl(fid); end; % Count Up the Lines
   Repository_Table = cell(lineCount-1,requiredColumns);
   fclose(fid);
   fid = fopen(strcat(pathname,filename));
   curCount = 1;
   tline = fgetl(fid);
   while ischar(tline)
    remaining = tline;
    across = 1;
    ignoring = 0;
    while(size(remaining,2) > 1)                
        for j = 1:(size(remaining,2))
            if ignoring == 1
                if strcmp(remaining(j),'"')
                    if j+1 < (size(remaining,2))
                        if strcmp(remaining(j+1),','), ignoring = 0; end;
                    end               
                end
            else
                if j == 1 && strcmp(remaining(1),'"')
                   ignoring = 1; 
                end
                if strcmp(remaining(j),',')
                    if strcmp(remaining(j+1),'"'), ignoring = 1; end;
                     if strcmp(remaining(1),'"') && strcmp(remaining(j-1),'"')
                        Repository_Table(curCount,across) = cellstr(remaining(2:(j - 2)));
                    else
                        Repository_Table(curCount,across) = cellstr(remaining(1:(j - 1)));
                    end
                    remaining = remaining((j + 1):end);
                    across = across + 1;
                    break;
                end 
            end
            if j == size(remaining,2)
               %copy this off
               Repository_Table(curCount,across) = cellstr(remaining(1:end));
               remaining = '';
            end
        end
    end
    curCount = curCount +1;
    tline = fgetl(fid);
   end
    fclose(fid);

    % Take First Column
    AffyIDs = Repository_Table(2:end,1);
    %match up in base aIDs?
    LookUpAffy = evalin('base','LookUpAffy');
    LookUpNum = evalin('base','LookUpNum');
    aIDs = -1;
    place = 1;
    for j = 1:size(AffyIDs,1)
        for i = 1:size(LookUpAffy,1)
            if strcmp(LookUpAffy(i),AffyIDs(j))
                aIDs(place,1) = LookUpNum(i);
                place = place + 1;
                break;
            end
        end
    end
    clear LookUpAffy LookUpNum 
    %Update search table accordingly
    assignin('base','a',aIDs);
    aIDs = evalin('base','a');
     if (size(aIDs,1) == 0), disp('NOT FOUND');
         %Say in table not found
         table = cell(1,4);
         table(1,3) = cellstr('Not Found');
         select = get(handles.searchMenu,'String');
         annot_columns = evalin('base','annotation.MiniGoTerms2(1,1:annotation.display)');
         set(handles.searchTable,'ColumnName',{ annot_columns{:} ,'Status', char(valstrings(val)) });
         set(handles.searchTable,'Data',table);
     else
         table = {}; % intilise data table
         for i = 1:size(aIDs,1) % Loop through Affy IDs
             assignin('base','c',aIDs(i));
             
             evalin('base','b = 0; for i = 1:size(Study.AffyIDNums), if Study.AffyIDNums(i) == c, b = 1; break; end; end');
             b = evalin('base','b');
             % In study or not?
             status = 'Unknown';
             if b == 0, status ='Found, not in study';
             else status = 'Found, in Study'; end;
             % throw into search table
             table(i,1) = evalin('base','LookUpAffy(c)');
             table(i,2) = evalin('base','MiniGoTerms2(c+1,15)');
             table(i,3) = cellstr(status);
         end
          set(handles.searchTable,'Data',table);
          select = get(handles.searchMenu,'String');
          annot_columns = evalin('base','annotation.MiniGoTerms2(1,1:annotation.display)');
         set(handles.searchTable,'ColumnName',{ annot_columns{:} ,'Status', char(valstrings(val)) });
          set(handles.searchTable,'ColumnWidth',{ 200, 80 ,120});
          set(handles.searchTable,'RowName',[]);
          
          evalin('base','clear a b c d i j iA attempted ans');
     end
    
end % end filename/dir checks

function sort_Search_Table(handles)
% SORT_SEARCH_TABLE sorts the search table by the Status of the search,
% such that found in study is at the top of the list
data = get(handles.searchTable,'Data');
% Note the xselect, yselect, pointslist must be assorted too
% Method generate new indexs for everything, first collect those thare are
% found
selector = strcmp(data(:,3),'Found, in Study');
%newtable = size(data);
if size(data,1) > 1
   % No need tosort if there is only 1 entry or none.
   newtable = data(selector,:);
   newtable(sum(selector)+1:size(selector,1),:) = data(not(selector),:);
   
   set(handles.searchTable,'Data',newtable); 
end







% --- Executes on button press in coloursFromProperitiesButton.
function coloursFromProperitiesButton_Callback(hObject, eventdata, handles)
% colorusFromProperitiesButton - this takes the selected columns from the 3
% drop down menu boxes at the bottom and replorts the t-sne plot with the
% colors from the properities.
propertitiesMatrix = zeros(evalin('base','size(Study.data,1)'),4);
set(handles.statusText,'String','Processing (Property colouring)...');
pause(0.001);

for x = 1:4
   % loop through each condition
   % Acquire column title
    titles = eval(sprintf('get(handles.prop%i,''String'');',x));
    colTitle = char(eval(sprintf('titles(get(handles.prop%i,''Value''));',x)));
   if strcmp(colTitle,'None'), continue; end;
    while true % Enter loop so we can use break to return     
        % Check aganist transcription Table
            try %Transcription Table might not exist
                toBreak = 0;
                tCols = evalin('base','Transcription_Table(1,:)');
                for i = 2:size(tCols,2)
                    if strcmp(char(tCols(i)),colTitle)
                          tempCol = evalin('base',sprintf('Transcription_Table(2:end,%i)',i));
                          tempAffy = evalin('base','Transcription_Nums(2:end,1)');
                         toBreak = 1;
                         break;
                    end
                end
                if toBreak == 1
                    break;
                end
            catch
            end
        % Search Go Terms/Annotation Fle
        annotateCols = evalin('base','MiniGoTerms2(1,:)');
        for i = 2:size(annotateCols,2)
           if strcmp(char(annotateCols(i)),colTitle)
                tempCol = evalin('base',sprintf('MiniGoTerms2(2:end,%i)',i));
                tempAffy = evalin('base','LookUpNum(:,1)');
               break;
           end
        end
        % Check aganist Affy IDs
        break;
    end
    try 
        tempCol;
    catch, 
        continue; 
    end;
    % test on conidtions
    selector = logical(zeros(size(tempCol)));
    for i = 1:size(tempCol,1)
        % HERE IS THE FILTER CODE
        try
            c = char(tempCol(i,1));
            if strcmp(c,'---') || strcmp(c,'-')
               continue;
            elseif strcmp(c(1),'0')
                d = str2double(c);
                if d == 0
                else 
                  selector(i,1) = true;
                end
            else
               selector(i,1) = true;
            end
        catch
            try
                if cell2mat(tempCol(i,1)) ~= 0
                    selector(i,1) = true;
                end
            catch
            end
        end
    end
    try
    toProcess = tempAffy(selector,1); %Filter by selection
    catch
       disp('Error: You must PreProcess before using the supplementary files');
       return;
    end
    %ToProcess is in LookUp Num format use cyclic loop to find Affys
    studyAffyNums = evalin('base','Study.AffyIDNums');
    indexToStudy = zeros(size(toProcess));
    iA = 1;
   for i = 1:size(toProcess,1)
       attempted = 1;
       while true,
           if attempted > size(studyAffyNums,1)*2,indexToStudy(i,1) = -1;
               break;
           end;
           if toProcess(i) == studyAffyNums(iA)
               indexToStudy(i,1) = iA;
               break;
           end;
           attempted = attempted + 1;
           iA = iA + 1;
           if iA > size(studyAffyNums,1),
               iA = 1;
           end;
       end;
   end  
   for i = 1:size(indexToStudy,1)
       if indexToStudy(i) ~= -1
            propertitiesMatrix(indexToStudy(i),x) = 1;
       end
   end   
end
    if get(handles.targetMenu,'Value') == 2
        evalin('base','figure');
    else
        try
        delete(handles.highlighted);
        catch
        end
    end
    handles.highlighted = [];
    % i = row index of one clicked
    

    %select = logical(zeros(size(propertitiesMatrix,1),1));
    %for i = 1:size(propertitiesMatrix,1)
    %    select(i,1) = sum(propertitiesMatrix(i,1:3)) > 0;
    %end
    colours = zeros(size(propertitiesMatrix,1),3);
    sizes = ones(size(propertitiesMatrix,1),1);
    for i = 1:size(propertitiesMatrix,1)
      
       %RGB first three columns 
       colours(i,:) = propertitiesMatrix(i,1:3);
       if sum(propertitiesMatrix(i,1:3)) > 0
           sizes(i,1) = 11;
       else
           sizes(i,1) = 6;
       end
    end

    tsneData = evalin('base','tsneData');
    scatter(tsneData(:,1),tsneData(:,2),sizes, colours, 'filled');

    warning off;
    axis tight off;
    warning on;
    set(handles.statusText,'String','');
    if get(handles.targetMenu,'Value') == 2
        try
        assignin('base','i',handles.selected(:,1));
        evalin('base','hold on');
        evalin('base','hh = plot(xselect(i),yselect(i),''o'');');
        evalin('base','set(hh,''Color'',''r'');');
        evalin('base','hold off');
        evalin('base','clear hh;');
        catch
        end
    end
    guidata(hObject, handles);

% --- Executes on button press in mosaicTableButton.
function mosaicTableButton_Callback(hObject, eventdata, handles)
%mosaicTableButton - imports the data from the mosaic selection tool and
%then it adds it to the uitable
try
delete(handles.highlighted);
catch
end

handles.highlighted = [];
handles.data = {};
evalin('base','clear transcriptionTable');
try
evalin('base','pointslist = mosaicPoints;');
evalin('base','xselect = tsneData(pointslist,1);');
evalin('base','yselect = tsneData(pointslist,2);');
catch
    disp('Fault: Detected in selection Tool Refreshing plot');
    evalin('base','scatter(tsneData(:,1),tsneData(:,2),8, [ 0 0 0], ''filled'');');
    axis tight off;
    return;
end
if evalin('base','length(pointslist) ~= 0')
%Acquire Affy IDs
%evalin('base','pointsListIndexs = { [] }; for i = 1:size(pointslist), pointsListIndexs(i,1) = num2cell(pointslist(i,1)); end');
%handles.data = evalin('base','pointsListIndexs');
%evalin('base','pointsListAffyIDs = cell(size(pointslist)); for i = 1:size(pointslist),  pointsListAffyIDs(i,1) = Study.AffyIDs(pointslist(i),1); end');
try
evalin('base','pointsListNums = Study.AffyIDNums(pointslist);');
catch
    disp('Fault: Detected in selection Tool Refreshing plot');
    evalin('base','scatter(tsneData(:,1),tsneData(:,2),8, [ 0 0 0], ''filled'');');
    axis tight off;
    return;
end

handles.data(:,1) = evalin('base','LookUpAffy(pointsListNums);');
%evalin('base','geneTitles = MiniGoTerms2(pointsListNums+1,14); geneSymbols = MiniGoTerms2(pointsListNums+1,15);');
annot_cols = evalin('base','annotation.display');
handles.data(:,2:annot_cols) = evalin('base','annotation.MiniGoTerms2(pointsListNums+1,2:annotation.display)');
%handles.data(:,3) = evalin('base','geneSymbols');

transSize = 0;
try
if evalin('base','exist(''Transcription_Table'')'),
    transSize = evalin('base','size(Transcription_Table,2)') - 1; %First column is affyIds so skip
    for i = 2:(transSize+1) % loop through columns
        warning off;
        evalin('base',sprintf('temp = cell(size(pointslist),1); for i = 1:size(pointslist,1), for j = 1:size(Transcription_Table,1), if pointsListNums(i) == Transcription_Nums(j), temp(i,1) = Transcription_Table(j,%i); break; end; end; end;',i));
        warning on;
        handles.data(:,annot_cols+(i-1)) = evalin('base','temp');
    end 
end
catch
    disp('Error: You need to preprocess.');
    return;
end

% Throw in raw data acquire from Study file

handles.data(:,(1+annot_cols)+transSize:((1+annot_cols)+transSize+(evalin('base','Study.groups')-1))) = num2cell(evalin('base','Study.data(pointslist,:)'));

% Gather data from Go Terms table

%handles.data(2:1) = evalin('base','pointsListAffyIDs');
set(handles.uitable1,'Data',handles.data);
set(handles.uitable1,'ColumnWidth',{ 200, 100});
% Columns names are set up at the start
t = handles.TableCNames;
t(1,1) = {sprintf('%s (selected: %i)',char(handles.TableCNames(1,1)),size(handles.data,1))};
set(handles.uitable1,'ColumnName',t);
set(handles.uitable1,'RowName',[]);
guidata(hObject, handles);
disp('Complete');

end


% --- Executes on button press in colourExpressionButton.
function colourExpressionButton_Callback(hObject, eventdata, handles)
%colourExpressionButton - replots the t-SNE plot based on the selected
%points from the Red/Green/Blue listboxes based on the expression from
%those conditions
redcolumn = get( handles.listbox1, 'Value' ); 
greencolumn = get( handles.listbox2, 'Value'); 
bluecolumn = get( handles.listbox3, 'Value'); 
evalin('base','data_0_to_1 = normalise_from_0_to_1(Study.data);');
%Require normalized data
%clrs = handles.alldata.colours( :, [ redcolumn, greencolumn, bluecolumn ] ); 
%handles.current_colours = clrs; 
if get(handles.targetMenu,'Value') == 2
    evalin('base','figure'); 
end
evalin('base',sprintf('scatter(tsneData(:,1),tsneData(:,2),12, data_0_to_1(:,[ %i %i %i ]), ''filled'');',redcolumn,greencolumn,bluecolumn));
evalin('base','warning off');
evalin('base','axis tight off');
if get(handles.targetMenu,'Value') == 1
    try
    delete(handles.highlighted);
    catch
    end
    handles.highlighted= [];
elseif get(handles.targetMenu,'Value') == 2
    try
    assignin('base','i',handles.selected(:,1));
    evalin('base','hold on');
    evalin('base','hh = plot(xselect(i),yselect(i),''o'');');
    evalin('base','set(hh,''Color'',''r'');');
    evalin('base','hold off');
    catch
    end
end

guidata(hObject, handles);


% --- Executes on button press in tsneExpressionButton.
function tsneExpressionButton_Callback(hObject, eventdata, handles)
%tsneExpressionButton - runs the t-SNE with the expression data instead of
%the z-scores and plots it.
set(handles.statusText,'String','Rendering t-SNE plot...');
pause(0.001);

evalin('base',sprintf('[mappedX,landmarks,costs] = fast_tsne(Study.data(:,:) ,2, Study.groups, 1, %i );',str2double(get(handles.perplexityValText,'String'))));

%Data comes back in wrong order however landmarks stores the correct order,
%so we'll put it back like that, this is also the most efficent way to
%reorder it :)
warning off;
evalin('base','tsneData = zeros(size(mappedX),2); for i = 1:size(tsneData,1), tsneData(landmarks(i),:) = mappedX(i,:); end');
warning on;

%Reorgniaze the tsneData by reordering by landmarks

evalin('base','scatter(tsneData(:,1),tsneData(:,2),8, [ 0 0 0], ''filled'');');
evalin('base','axis tight');
evalin('base','axis off');
evalin('base','xselect = []; yselect = []; pointslist = [];');
handles.highlighted= [];
guidata(hObject, handles);
set(handles.statusText,'String','Render Complete. You may now manipulate the t-SNE plot.');




% --- Executes on button press in tsneFoldInduction.
function tsneFoldInduction_Callback(hObject, eventdata, handles)
% hObject    handle to tsneFoldInduction (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.statusText,'String','Rendering t-SNE plot...');
pause(0.001);

evalin('base',sprintf('[mappedX,landmarks,costs] = fast_tsne(Study.foldInduction(:,:) ,2, Study.groups, 1, %i );',str2double(get(handles.perplexityValText,'String'))));

%Data comes back in wrong order however landmarks stores the correct order,
%so we'll put it back like that, this is also the most efficent way to
%reorder it :)
warning off;
evalin('base','tsneData = zeros(size(mappedX),2); for i = 1:size(tsneData,1), tsneData(landmarks(i),:) = mappedX(i,:); end');
warning on;

%Reorgniaze the tsneData by reordering by landmarks

evalin('base','scatter(tsneData(:,1),tsneData(:,2),8, [ 0 0 0], ''filled'');');
evalin('base','axis tight');
evalin('base','axis off');
evalin('base','xselect = []; yselect = []; pointslist = [];');
handles.highlighted= [];
guidata(hObject, handles);
set(handles.statusText,'String','Render Complete. You may now manipulate the t-SNE plot.');




% --- Executes on button press in tsnePercentInduction.
function tsnePercentInduction_Callback(hObject, eventdata, handles)
% hObject    handle to tsnePercentInduction (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.statusText,'String','Rendering t-SNE plot...');
pause(0.001);

evalin('base',sprintf('[mappedX,landmarks,costs] = fast_tsne(Study.percentInduction(:,:) ,2, Study.groups, 1, %i );',str2double(get(handles.perplexityValText,'String'))));

%Data comes back in wrong order however landmarks stores the correct order,
%so we'll put it back like that, this is also the most efficent way to
%reorder it :)
warning off;
evalin('base','tsneData = zeros(size(mappedX),2); for i = 1:size(tsneData,1), tsneData(landmarks(i),:) = mappedX(i,:); end');
warning on;

%Reorgniaze the tsneData by reordering by landmarks

evalin('base','scatter(tsneData(:,1),tsneData(:,2),8, [ 0 0 0], ''filled'');');
evalin('base','axis tight');
evalin('base','axis off');
evalin('base','xselect = []; yselect = []; pointslist = [];');
handles.highlighted= [];
guidata(hObject, handles);
set(handles.statusText,'String','Render Complete. You may now manipulate the t-SNE plot.');






    
% --- Executes on button press in removeColours.
function removeColours_Callback(hObject, eventdata, handles)
% replots the tsneData, in the plain black
if get(handles.targetMenu,'Value') == 2
    evalin('base','figure');
    
end
evalin('base','scatter(tsneData(:,1),tsneData(:,2),8, [ 0 0 0], ''filled'');');
axis tight off;
if get(handles.targetMenu,'Value') == 2
    try
    assignin('base','i',handles.selected(:,1));
    evalin('base','hold on');
    evalin('base','hh = plot(xselect(i),yselect(i),''o'');');
    evalin('base','set(hh,''Color'',''r'');');
    evalin('base','hold off');
    catch
    end
end

function perplexityValText_Callback(hObject, eventdata, handles)
%PerplexityValText - this stores the value of the user define perplexity
% and ensures the perplexitiy is a whole number between 0 and 50,000, as to
%avoid errors.
num = round(str2double(get(hObject,'String')));
min = 0;
max = 50000;
if num > max, num = max; end;
if num < min, num = min; end;
set(hObject,'String',sprintf('%i',num));

% --- Executes on button press in tsneZeroMeans.
function tsneZeroMeans_Callback(hObject, eventdata, handles)
%THIS USE TO BE FOR tsneZeroMeans - plots a t-SNE based on the robust distance t-SNE created by
%Now Uses Zero means
set(handles.statusText,'String','Rendering t-SNE plot...');
pause(0.001);

evalin('base',sprintf('[mappedX,landmarks,costs] = fast_tsne(Study.zero_means(:,:) ,2, Study.groups, 1, %i );',str2double(get(handles.perplexityValText,'String'))));

%Data comes back in wrong order however landmarks stores the correct order,
%so we'll put it back like that, this is also the most efficent way to
%reorder it :)
warning off;
evalin('base','tsneData = zeros(size(mappedX),2); for i = 1:size(tsneData,1), tsneData(landmarks(i),:) = mappedX(i,:); end');
warning on;

%Reorgniaze the tsneData by reordering by landmarks

evalin('base','scatter(tsneData(:,1),tsneData(:,2),8, [ 0 0 0], ''filled'');');
evalin('base','axis tight');
evalin('base','axis off');
evalin('base','xselect = []; yselect = []; pointslist = [];');
handles.highlighted= [];
guidata(hObject, handles);
set(handles.statusText,'String','Render Complete. You may now manipulate the t-SNE plot.');

  

%evalin('base',sprintf('[tsneData, P] = tsne_pdistance(Study.data(:,:), [], 2, Study.groups, %i, @(x)(pairwise_robust_distances(x,1)));',str2double(get(handles.perplexityValText,'String'))));

%evalin('base','scatter(tsneData(:,1),tsneData(:,2),8, [ 0 0 0], ''filled'');');
%evalin('base','axis tight');
%evalin('base','axis off');
%evalin('base','xselect = []; yselect = []; pointslist = [];');

% --- Executes on button press in clearSupp.
function clearSupp_Callback(hObject, eventdata, handles)
%clearSupp - unloads the supplmentry annotation files that have been loaded
% and empties the variables that store the quanitiy, and updates the title
% of the GUI window.
evalin('base','clear Transcription_Table Transcription_Nums');
handles.supplementries_Loaded = 0;
handles.supplementries_loaded = {};
try
set(handles.figure1,'Name',sprintf('Analysis Tool - Study ( Rep: %s Genes: %i ) Annotation ( Primary - %s Supplementaries Loaded - %i )',evalin('base','Study.name'),evalin('base','size(Study.raw,1)'),handles.annotation_loaded,handles.supplementries_Loaded));
catch
end
guidata(hObject, handles);

function panelSelectionMenu_Callback(hObject, eventdata, handles)
%panelSelectionMenu - this handles the events when the user picks the pane
%to display on the right side.
val = get(hObject,'Value');
set(handles.toolsPanelLoad,'visible','off');
set(handles.toolPanelsTable,'visible','off');
set(handles.toolsPanelColours,'visible','off');
 set(handles.toolPanelsNotes,'visible','off');
if val == 1
    set(handles.toolsPanelLoad,'visible','on');
elseif val == 2
    set(handles.toolPanelsTable,'visible','on');
elseif val == 3
    set(handles.toolsPanelColours,'visible','on');
elseif val == 4
    set(handles.toolPanelsNotes,'visible','on');
end        


function colourNonDuplicatesButton_Callback(hObject, eventdata, handles)
% colourNonDuplicates - this button is to deal with the colouring of lists,
% which for certain wont contain duplicates, it will still work but there
% won't be indication if there are overlaps

set(handles.statusText,'String','Processing (Unique property colouring)...');
pause(0.001);

%Initalize
colours = zeros(evalin('base','size(Study.data,1)'),3);
sizes = 7*ones(evalin('base','size(Study.data,1)'),1);

t = get(handles.colourNonDuplicatesTable,'Data');

%Search tables and mark genes with colours/sizes and bind to Study
try
tCols = evalin('base','Transcription_Table(1,:)');
catch
   tCols = {}; 
end
annotateCols = evalin('base','MiniGoTerms2(1,:)');
studyNums = evalin('base','Study.AffyIDNums');
for x = 1:size(t,1)
   if not(strcmp(char(t(x,2)),'None'))
       %Now we take we find column X in the annotation files.
       %Try supplementary
         toBreak = 0;
         for i = 2:size(tCols,2)
            if strcmp(char(tCols(i)),char(t(x,2)))
                tempCol = evalin('base',sprintf('Transcription_Table(2:end,%i)',i));
                tempAffy = evalin('base','Transcription_Nums(2:end,1)');
                toBreak = 1;
                break;
            end
         end
         if toBreak == 0
            %Primary Annotation look up
            for i = 2:size(annotateCols,2)
               if strcmp(char(annotateCols(i)),char(t(x,2)))
                   tempCol = evalin('base',sprintf('MiniGoTerms2(2:end,%i)',i));
                   tempAffy = evalin('base','LookUpNum(:,1)');
                   toBreak = 1;
                   break;
               end
            end
         end
         if toBreak == 1 %Column exists, so lets use it
               selector = logical(zeros(size(tempCol)));
                for i = 1:size(tempCol,1)
                    % HERE IS THE FILTER CODE
                    try
                        c = char(tempCol(i,1));
                        if strcmp(c,'---') || strcmp(c,'-')
                           continue;
                        elseif strcmp(c(1),'0')
                            d = str2double(c);
                            if d == 0
                            else 
                              selector(i,1) = true;
                            end
                        else
                           selector(i,1) = true;
                        end
                    catch
                        try
                            if cell2mat(tempCol(i,1)) ~= 0
                                selector(i,1) = true;
                            end
                        catch
                        end
                    end
                end
             tempAffy = tempAffy(selector,1);
            
             iA = 1;
              %Cyclic Looping
             for i = 1:size(studyNums,1);
                attempted  = 1;
                while true
                    if attempted == size(tempAffy,1), break; end;
                    if (studyNums(i,1) == tempAffy(iA,1)) 
                       %now  apply sizes colours
                       sizes(i,1) = 12;
                       if x == 1, colours(i,:) = [0 1 0]; % Green
                       elseif x == 2, colours(i,:) = [1 0 0]; % Red
                       elseif x == 3, colours(i,:) = [0 0 1]; % Blue
                       elseif x == 4, colours(i,:) = [0 0 0]; % black
                       elseif x == 5, colours(i,:) = [1 0.5 0]; % orange
                       elseif x == 6, colours(i,:) = [1 1 0]; % yellow        
                       elseif x == 7, colours(i,:) = [1 0 1]; % Magneta   
                       elseif x == 8, colours(i,:) = [0 1 1]; % Cyan    
                       elseif x == 9, colours(i,:) = [0.5 0.4 0.5]; % lighter grey   
                       elseif x == 10, colours(i,:) = [1 0.5 0.5]; % peach
                       end;
                       %switch colours
                       break;
                    end
                    iA = iA +1;
                    attempted = attempted + 1;
                    if iA > size(tempAffy,1)
                        iA = 1;
                    end
                end           
             end             
         end
       %Primary Annotation
   end
end

%Apply Changes
    if get(handles.targetMenu,'Value') == 2
        evalin('base','figure');
    else
        try
        delete(handles.highlighted);
        catch
        end
    end
    handles.highlighted = [];
        tsneData = evalin('base','tsneData');
    scatter(tsneData(:,1),tsneData(:,2),sizes, colours, 'filled');

    warning off;
    axis tight off;
    warning on;
    set(handles.statusText,'String','');
    if get(handles.targetMenu,'Value') == 2
        try
        assignin('base','i',handles.selected(:,1));
        evalin('base','hold on');
        evalin('base','hh = plot(xselect(i),yselect(i),''o'');');
        evalin('base','set(hh,''Color'',''r'');');
        evalin('base','hold off');
        catch
        end
    end
    guidata(hObject, handles);
    set(handles.statusText,'String','Idle.');

    
    % --- Executes on button press in costColourButton.
function costColourButton_Callback(hObject, eventdata, handles)
%costColourButton - applies colours from the cost variable
colours = zeros(evalin('base','size(tsneData,1)'),3);

try
costs = evalin('base','costs');
catch
   disp('ERROR: No costs detected. This was probably caused by loading old exported set which is missing the costs data.');
   return;
end
landmarks = evalin('base','landmarks');
costs = costs(landmarks,:);
costs01 = normalise_from_0_to_1(costs);
sizes = 12*ones(size(colours,1),1);
colours(:,1) = costs01;
colours(:,2) = costs01;
colours(:,3) = costs01;
for i = 1:size(colours,1)
   sizes(i,1) = ((2+9*costs01(i,1))*(2+9*costs01(i,1)));
end
assignin('base','colours',colours);
assignin('base','sizes',sizes);
if get(handles.targetMenu,'Value') == 2
    evalin('base','figure');
end
evalin('base','scatter(tsneData(:,1),tsneData(:,2),sizes, colours, ''filled'');');
warning off;
axis tight off;
if get(handles.targetMenu,'Value') == 2
    try
    assignin('base','i',handles.selected(:,1));
    
    evalin('base','hold on');
    evalin('base','hh = plot(xselect(i),yselect(i),''o'');');
    evalin('base','set(hh,''Color'',''r'');');
    evalin('base','hold off');
    
    catch
    end
end
warning on;
evalin('base','clear sizes colours;');



function plotSuppAnno_Callback(hObject, eventdata, handles)
% plotSuppAnno - takes selected probes from the main table and will plot
% them on a subplot

pointsList = evalin('base','pointslist');
pointsList(handles.selected(:,1));
%indexs will match those from the graph, pointslist will match

guidata(hObject, handles);
if not( isempty( handles.selected) )
    if evalin('base','exist(''Transcription_Table'')')
        sizeT = evalin('base','size(Transcription_Table)');
        t = get(handles.uitable1,'Data');
        t = t(unique(handles.selected(:,1)),:);
        t = t(:,1:sizeT(2));
        tNums = zeros(size(t,1),size(t,2)-1); % remove affy IDs
        
        for j = 1:size(tNums,2) % Columns
           for i = 1:size(tNums,1) % rows
               try
                   temp = str2double(char(t(i,j+1)));
               catch
                   temp = 0;
               end
               try
                   if ~isnan(temp)
                     tNums(i,j) = temp;
                   end
               catch
               end
           end
       end
        
        % Column 1 = Affy ID, rest are supplmentry annotation file.
        f1 = figure; % Create a new figure
        set(f1, 'color', 'white'); % White background on the graph
        hold on % ensures all lines stay on the same figure
        % Plot each gene on the figure
        for i = 1:size(tNums,1)
            plot(1:size(tNums,2),tNums(i,:));  
        end


        % plot at lowest y value
        % Assemble the conditions/times as a X Label.

        xlabels = cell(size(tNums,2),1);
        for i = 1:size(tNums,2)
            xlabels(i) = evalin('base',sprintf('Transcription_Table(1,%i)',i+1));
        end
        hold off % We no longer require to put more plots on the figure.
        title('Z Scores of Subset');
        set(gca, 'Box', 'off' );
        ylabel('Z Values');
        set(gca,'XTick',1:size(tNums,2)); % Ensure that a 'pointer' on the figure edge exists for each condition.
        set(gca,'XTickLabel',xlabels); % Label them
        a=get(gca,'XTickLabel');
        %erase current tick labels from figure
        set(gca,'XTickLabel',[]);
        %get tick label positions
        b=get(gca,'XTick');
        c=get(gca,'YTick');
        rot=45;
        %make new tick labels
        if rot<180
            text(b,repmat(c(1)-.05*(c(2)-c(1)),length(b),1),a,'HorizontalAlignment','right','rotation',rot,'FontSize', 10, 'FontWeight', 'normal');
        else
            text(b,repmat(c(1)-.05*(c(2)-c(1)),length(b),1),a,'HorizontalAlignment','left','rotation',rot, 'FontSize', 10, 'FontWeight', 'normal');
        end
    else% If transcription table doesn't exist.
        disp('Error: to use the plot supplmentry annotation tool you must have loaded a supplmentry annotation file');
    end 
   end
% --- Executes on button press in bullseyeButton.
function bullseyeButton_Callback(hObject, eventdata, handles)
%take nearest point - produces a bullseye plot from the nearest point
set(handles.statusText,'String','Click on the t-SNE plot, nearest point will be taken.');
pause(0.001);

disp('redo');
evalin('base','scatter(tsneData(:,1),tsneData(:,2),8, [ 0 0 0], ''filled'');');
axis tight off;

pause(0.01);

[pointNum] = selectcordinate();

set(handles.statusText,'String','Processing bullseye...');
pause(0.001);
%Calculate point distances
% loop through points, take raw scores

data = evalin('base','Study.data_z_scores');

% calculate distances
try
distances = sum((data - repmat(data(pointNum,:),[size(data,1) 1 ])).^2,2);
catch
    try
        t = cell2mat(pointNum(1,1));
        distances = sum((data - repmat(data(t,:),[size(data,1) 1 ])).^2,2);
    catch
        t = cell2mat(pointNum(2,1));
        distances = sum((data - repmat(data(t,:),[size(data,1) 1 ])).^2,2);
    end
end

%sort to closest
[newdist newi] = sort(distances);


    %colour nearest ten, point = red, green = next 4, red = final 5
    colours = zeros(size(data,1),3);
    colours(newi(1,:),:) = [ 1 0 0];
    colours(newi(2:5,:),:) = repmat([ 0 1 0], [ 4 1]);
    colours(newi(6:10,:),:) = repmat([ 0 0 1], [ 5 1]);
    if get(handles.targetMenu,'Value') == 2
        evalin('base','figure');
    end
    tsneData = evalin('base','tsneData');
    scatter(tsneData(:,1),tsneData(:,2),9, colours, 'filled');
    warning off;
    axis tight off;
    warning on;
    
set(handles.statusText,'String','Idle.');

function plotSuppAnnoLegend_Callback(hObject, eventdata, handles)
% plotSuppAnnoLegend - takes selected probes from the main table and will plot
% them on a subplot with a legend

pointsList = evalin('base','pointslist');
pointsList(handles.selected(:,1));
%indexs will match those from the graph, pointslist will match

guidata(hObject, handles);
if not( isempty( handles.selected) )
    if evalin('base','exist(''Transcription_Table'')')
        sizeT = evalin('base','size(Transcription_Table)');
        t = get(handles.uitable1,'Data');
        t = t(unique(handles.selected(:,1)),:);
        t = t(:,1:sizeT(2));
        tNums = zeros(size(t,1),size(t,2)-1); % remove affy IDs
        
        for j = 1:size(tNums,2) % Columns
           for i = 1:size(tNums,1) % rows
               try
                   temp = str2double(char(t(i,j+1)));
               catch
                   temp = 0;
               end
               try
                   if ~isnan(temp)
                     tNums(i,j) = temp;
                   end
               catch
               end
           end
       end
        
        % Column 1 = Affy ID, rest are supplmentry annotation file.
        f1 = figure; % Create a new figure
        set(f1, 'color', 'white'); % White background on the graph
        hold on % ensures all lines stay on the same figure
        % Plot each gene on the figure
        for i = 1:size(tNums,1)
            a = 3.1415*2*(i / size(tNums,1));
            col = [ ((sin(a+(3.14/2))+1)/2) ((sin(a)+1)/2) ((sin(a+3.14)+1)/2) ];
            plot(1:size(tNums,2),tNums(i,:),'Color',col);  
        end
        
        %colour/legend code
       
        ids = evalin('base','Study.AffyIDs');
        ids = ids(unique(handles.selected(:,1)));
        legend(get(f1,'Children'),ids);


        % plot at lowest y value
        % Assemble the conditions/times as a X Label.

        xlabels = cell(size(tNums,2),1);
        for i = 1:size(tNums,2)
            xlabels(i) = evalin('base',sprintf('Transcription_Table(1,%i)',i+1));
        end
        hold off % We no longer require to put more plots on the figure.
        title('Z Scores of Subset');
        set(gca, 'Box', 'off' );
        ylabel('Z Values');
        set(gca,'XTick',1:size(tNums,2)); % Ensure that a 'pointer' on the figure edge exists for each condition.
        set(gca,'XTickLabel',xlabels); % Label them
        a=get(gca,'XTickLabel');
        %erase current tick labels from figure
        set(gca,'XTickLabel',[]);
        %get tick label positions
        b=get(gca,'XTick');
        c=get(gca,'YTick');
        rot=45;
        %make new tick labels
        if rot<180
            text(b,repmat(c(1)-.05*(c(2)-c(1)),length(b),1),a,'HorizontalAlignment','right','rotation',rot,'FontSize', 10, 'FontWeight', 'normal');
        else
            text(b,repmat(c(1)-.05*(c(2)-c(1)),length(b),1),a,'HorizontalAlignment','left','rotation',rot, 'FontSize', 10, 'FontWeight', 'normal');
        end
    else% If transcription table doesn't exist.
        disp('Error: to use the plot supplmentry annotation tool you must have loaded a supplmentry annotation file');
    end 
end

   
% --- Executes on button press in neighbourPlot_Button.
function neighbourPlot_Button_Callback(hObject, eventdata, handles)
% Newly found neighbour plot Button
gui_neighbour

% set(handles.statusText,'String','Plotting neighbour plot.');
% evalin('base','figure;');
% %evalin('base','scatter(tsneData(:,1),tsneData(:,2),8, [ 0 0 0], ''filled'');')
% evalin('base','hold on');
% evalin('base','neighbour_plot(tsneData,Study.data_z_scores,1,2,0.5,0.3,jet);');
% evalin('base','hold off');
% evalin('base','axis tight');
% evalin('base','axis off');
% 
% set(handles.statusText,'String','Plot complete.');

%%%%%%%%%%%%%%%
%  tsneData = evalin('base','tsneData');
%  zScores = evalin('base','Study.data_z_scores');
% neighbour_plot(tsneData,zScores,1,2,0.5,0.3,jet);
% axis tight off;
%% Useless Code below
%
% Code remains so that functions may be used later if required
%

function prop1_Callback(hObject, eventdata, handles)

function prop1_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function prop2_Callback(hObject, eventdata, handles)

function prop2_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function prop3_Callback(hObject, eventdata, handles)

function prop3_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function prop4_Callback(hObject, eventdata, handles)

function prop4_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function statusText_Callback(hObject, eventdata, handles)

function statusText_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function searchText_KeyPressFcn(hObject, eventdata, handles)
if (strcmp(eventdata.Key,'return'))
    searchButton_Callback(handles.searchButton, eventdata, handles);
end

function listbox1_Callback(hObject, eventdata, handles)

function listbox1_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function listbox2_Callback(hObject, eventdata, handles)

function listbox2_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function listbox3_Callback(hObject, eventdata, handles)

function listbox3_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function targetMenu_Callback(hObject, eventdata, handles)

function targetMenu_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function perplexityValText_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function searchText_Callback(hObject, eventdata, handles)

function searchText_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function searchMenu_Callback(hObject, eventdata, handles)

function searchMenu_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function panelSelectionMenu_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function figure1_ResizeFcn(hObject, eventdata, handles)

function anaNotesText_Callback(hObject, eventdata, handles)

function anaNotesText_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function studyNotesText_Callback(hObject, eventdata, handles)

function studyNotesText_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function repoNotesText_Callback(hObject, eventdata, handles)

function repoNotesText_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in plotZeroRowMeans.
function plotZeroRowMeans_Callback(hObject, eventdata, handles)
% hObject    handle to plotZeroRowMeans (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
pointsList = evalin('base','pointslist');
pointsList(handles.selected(:,1));
%indexs will match those from the graph, pointslist will match

guidata(hObject, handles);
if not( isempty( handles.selected) )
    rawData = evalin('base','Study.zero_means');
    rawData = rawData(unique(pointsList(handles.selected(:,1))),:);
    
    f1 = figure; % Create a new figure
    set(f1, 'color', 'white'); % White background on the graph
    hold on % ensures all lines stay on the same figure
    % Plot each gene on the figure
     for i = 1:size(rawData,1)
        plot(1:size(rawData,2),rawData(i,:));
     end
    % plot at lowest y value
    % Assemble the conditions/times as a X Label.
    xlabels = cell(size(rawData,2));
    for i = 1:size(rawData,2)
        xlabels(i) = evalin('base',sprintf('Study.ColumnIDs(%i)',i));
    end
    hold off % We no longer require to put more plots on the figure.
    title('Zero Row Means');
    set(gca, 'Box', 'off' );
    ylabel('zero row mean values');
    set(gca,'XTick',1:size(rawData,2)); % Ensure that a 'pointer' on the figure edge exists for each condition.
    set(gca,'XTickLabel',xlabels); % Label them

   end



% --- Executes on button press in plotZeroRowMeansLegend.
function plotZeroRowMeansLegend_Callback(hObject, eventdata, handles)
% hObject    handle to plotZeroRowMeansLegend (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

pointsList = evalin('base','pointslist');
pointsList(handles.selected(:,1));
%indexs will match those from the graph, pointslist will match

guidata(hObject, handles);
if not( isempty( handles.selected) )
    rawData = evalin('base','Study.zero_means');
    rawData = rawData(unique(pointsList(handles.selected(:,1))),:);
    
    f1 = figure; % Create a new figure
    set(f1, 'color', 'white'); % White background on the graph
    hold on % ensures all lines stay on the same figure
    % Plot each gene on the figure
     for i = 1:size(rawData,1)
        a = 3.1415*2*(i / size(rawData,1));
        col = [ ((sin(a+(3.14/2))+1)/2) ((sin(a)+1)/2) ((sin(a+3.14)+1)/2) ];
        plot(1:size(rawData,2),rawData(i,:),'Color',col);
    end
     ids = evalin('base','Study.AffyIDs');
    ids = ids(unique(pointsList(handles.selected(:,1))));
    legend(get(f1,'Children'),ids);
    % plot at lowest y value
    % Assemble the conditions/times as a X Label.
    xlabels = cell(size(rawData,2));
    for i = 1:size(rawData,2)
        xlabels(i) = evalin('base',sprintf('Study.ColumnIDs(%i)',i));
    end
    hold off % We no longer require to put more plots on the figure.
    title('Zero row means');
    set(gca, 'Box', 'off' );
    ylabel('Zero row mean values');
    set(gca,'XTick',1:size(rawData,2)); % Ensure that a 'pointer' on the figure edge exists for each condition.
    set(gca,'XTickLabel',xlabels); % Label them

   end



% --- Executes on button press in plotPercentInduction.
function plotPercentInduction_Callback(hObject, eventdata, handles)
% hObject    handle to plotPercentInduction (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

pointsList = evalin('base','pointslist');
pointsList(handles.selected(:,1));
%indexs will match those from the graph, pointslist will match

guidata(hObject, handles);
if not( isempty( handles.selected) )
    rawData = evalin('base','Study.percentInduction');
    rawData = rawData(unique(pointsList(handles.selected(:,1))),:);
    
    f1 = figure; % Create a new figure
    set(f1, 'color', 'white'); % White background on the graph
    hold on % ensures all lines stay on the same figure
    % Plot each gene on the figure
     for i = 1:size(rawData,1)
        plot(1:size(rawData,2),rawData(i,:));
     end
    % plot at lowest y value
    % Assemble the conditions/times as a X Label.
    xlabels = cell(size(rawData,2));
    for i = 1:size(rawData,2)
        xlabels(i) = evalin('base',sprintf('Study.ColumnIDs(%i)',i));
    end
    hold off % We no longer require to put more plots on the figure.
    title('Percent Induction');
    set(gca, 'Box', 'off' );
    ylabel('percent induction value');
    set(gca,'XTick',1:size(rawData,2)); % Ensure that a 'pointer' on the figure edge exists for each condition.
    set(gca,'XTickLabel',xlabels); % Label them

   end
% --- Executes on button press in plotPercentInductionLegend.
function plotPercentInductionLegend_Callback(hObject, eventdata, handles)
% hObject    handle to plotPercentInductionLegend (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

pointsList = evalin('base','pointslist');
pointsList(handles.selected(:,1));
%indexs will match those from the graph, pointslist will match

guidata(hObject, handles);
if not( isempty( handles.selected) )
    rawData = evalin('base','Study.percentInduction');
    rawData = rawData(unique(pointsList(handles.selected(:,1))),:);
    
    f1 = figure; % Create a new figure
    set(f1, 'color', 'white'); % White background on the graph
    hold on % ensures all lines stay on the same figure
    % Plot each gene on the figure
     for i = 1:size(rawData,1)
        a = 3.1415*2*(i / size(rawData,1));
        col = [ ((sin(a+(3.14/2))+1)/2) ((sin(a)+1)/2) ((sin(a+3.14)+1)/2) ];
        plot(1:size(rawData,2),rawData(i,:),'Color',col);
    end
     ids = evalin('base','Study.AffyIDs');
    ids = ids(unique(pointsList(handles.selected(:,1))));
    legend(get(f1,'Children'),ids);
    % plot at lowest y value
    % Assemble the conditions/times as a X Label.
    xlabels = cell(size(rawData,2));
    for i = 1:size(rawData,2)
        xlabels(i) = evalin('base',sprintf('Study.ColumnIDs(%i)',i));
    end
    hold off % We no longer require to put more plots on the figure.
    title('Percent Induction');
    set(gca, 'Box', 'off' );
    ylabel('percent induction value');
    set(gca,'XTick',1:size(rawData,2)); % Ensure that a 'pointer' on the figure edge exists for each condition.
    set(gca,'XTickLabel',xlabels); % Label them

   end




% --- Executes on button press in plotfoldinduction.
function plotfoldinduction_Callback(hObject, eventdata, handles)
% hObject    handle to plotfoldinduction (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
pointsList = evalin('base','pointslist');
pointsList(handles.selected(:,1));
%indexs will match those from the graph, pointslist will match

guidata(hObject, handles);
if not( isempty( handles.selected) )
    rawData = evalin('base','Study.foldInduction');
    rawData = rawData(unique(pointsList(handles.selected(:,1))),:);
    
    f1 = figure; % Create a new figure
    set(f1, 'color', 'white'); % White background on the graph
    hold on % ensures all lines stay on the same figure
    % Plot each gene on the figure
     for i = 1:size(rawData,1)
        plot(1:size(rawData,2),rawData(i,:));
     end
    % plot at lowest y value
    % Assemble the conditions/times as a X Label.
    xlabels = cell(size(rawData,2));
    for i = 1:size(rawData,2)
        xlabels(i) = evalin('base',sprintf('Study.ColumnIDs(%i)',i));
    end
    hold off % We no longer require to put more plots on the figure.
    title('Fold Induction');
    set(gca, 'Box', 'off' );
    ylabel('fold induction value');
    set(gca,'XTick',1:size(rawData,2)); % Ensure that a 'pointer' on the figure edge exists for each condition.
    set(gca,'XTickLabel',xlabels); % Label them

   end

% --- Executes on button press in plotFoldInductionLegend.
function plotFoldInductionLegend_Callback(hObject, eventdata, handles)
% hObject    handle to plotFoldInductionLegend (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

pointsList = evalin('base','pointslist');
pointsList(handles.selected(:,1));
%indexs will match those from the graph, pointslist will match

guidata(hObject, handles);
if not( isempty( handles.selected) )
    rawData = evalin('base','Study.foldInduction');
    rawData = rawData(unique(pointsList(handles.selected(:,1))),:);
    
    f1 = figure; % Create a new figure
    set(f1, 'color', 'white'); % White background on the graph
    hold on % ensures all lines stay on the same figure
    % Plot each gene on the figure
     for i = 1:size(rawData,1)
        a = 3.1415*2*(i / size(rawData,1));
        col = [ ((sin(a+(3.14/2))+1)/2) ((sin(a)+1)/2) ((sin(a+3.14)+1)/2) ];
        plot(1:size(rawData,2),rawData(i,:),'Color',col);
    end
     ids = evalin('base','Study.AffyIDs');
    ids = ids(unique(pointsList(handles.selected(:,1))));
    legend(get(f1,'Children'),ids);
    % plot at lowest y value
    % Assemble the conditions/times as a X Label.
    xlabels = cell(size(rawData,2));
    for i = 1:size(rawData,2)
        xlabels(i) = evalin('base',sprintf('Study.ColumnIDs(%i)',i));
    end
    hold off % We no longer require to put more plots on the figure.
    title('Fold Induction');
    set(gca, 'Box', 'off' );
    ylabel('fold induction value');
    set(gca,'XTick',1:size(rawData,2)); % Ensure that a 'pointer' on the figure edge exists for each condition.
    set(gca,'XTickLabel',xlabels); % Label them

   end


