function varargout = gui_annotation(varargin)
% GUI_ANNOTATION M-file for gui_annotation.fig
%      GUI_ANNOTATION, by itself, creates a new GUI_ANNOTATION or raises the existing
%      singleton*.
%
%      H = GUI_ANNOTATION returns the handle to a new GUI_ANNOTATION or the handle to
%      the existing singleton*.
%
%      GUI_ANNOTATION('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GUI_ANNOTATION.M with the given input arguments.
%
%      GUI_ANNOTATION('Property','Value',...) creates a new GUI_ANNOTATION or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before gui_annotation_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to gui_annotation_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help gui_annotation

% Last Modified by GUIDE v2.5 27-Jul-2011 11:28:00

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @gui_annotation_OpeningFcn, ...
                   'gui_OutputFcn',  @gui_annotation_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before gui_annotation is made visible.
function gui_annotation_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to gui_annotation (see VARARGIN)

% Choose default command line output for gui_annotation
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes gui_annotation wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = gui_annotation_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in loadAnnotationFile.
function loadAnnotationFile_Callback(hObject, eventdata, handles)
%loadAnnotationFile - This button is the annotation load button, it will load the
%file, and then store it in the gui workspace, as well as keep the user
%informed.

[filename, pathname] = uigetfile({'*.csv';'*.txt';'*.*'},'Select an Annotation File to load.','../');
handles.filename = filename;
if isequal(filename,0) || isequal(pathname,0)
else
    set(handles.statusBarText,'String','Loading File... (This can take a few minutes).');
    pause(0.001); % Pause to allow MATLAB to update the text, 
    %it wont change until the rest of the instructions are carried out otherwise.
    
    MiniGoTerms2 = parseCsvFile(filename,pathname);
    %Filter off columns that begin with the hash character this obselete
    %information about the annotation when using it with genes.
    keep = true(size(MiniGoTerms2,1),1);
    for i = 1:size(MiniGoTerms2,1)
        s = char(MiniGoTerms2(i,1));
        if (strcmp(s(1),'#'))
            keep(i,1) = false;
        end
    end
    MiniGoTerms2 = MiniGoTerms2(keep,:);
    [new newi] = sort(MiniGoTerms2(2:end,1));
    MiniGoTerms2(2:end,:) = MiniGoTerms2(newi+1,:);
    handles.MiniGoTerms2 = MiniGoTerms2;  
    guidata(hObject, handles);
    set(handles.statusBarText,'String',sprintf('Finished loading. Please save.',i,size(MiniGoTerms2,1)));
    
    % Column one
data(:,1) = MiniGoTerms2(1,2:end);
% 'Do not display'
for i = 1:size(data,1)
   data(i,2) = cellstr('Do not display'); 
end
%data(:,2) = cellstr(num2str(ones(size(MiniGoTerms2(1,2:end),1))));
%data(:,2) = cellfun(@cellstr,data(:,2),'Do not display');

val =  size(MiniGoTerms2(1,2:end),2);
sstring = 'set(handles.uitable1,''ColumnFormat'',{''char'',{ ''Do not display'' ';
for i = 1:val
    sstring = sprintf('%s ''%i'' ',sstring,i);
end
sstring = strcat(sstring,'}});');
eval(sstring);

set(handles.uitable1,'ColumnName',{'Column Name' , 'Display in Analysis tool'});
set(handles.uitable1,'ColumnEditable', [ false true] );
set(handles.uitable1,'Data',data);
set(handles.uitable1,'ColumnWidth',{250, 'auto'});
    
    % DUMP COLUMN HEADERS TO THE table, look at the code in the repo stage
end



function saveButton_Callback(hObject, eventdata, handles)
%saveButton - saves off the stored data saved from the previous button.
[filename, pathname] = uiputfile('*.mat','Save Study',strcat('../data/libraries/',handles.filename,'-Annotation.mat'));
if isequal(filename,0) || isequal(pathname,0)
else
    
    % process table
    data = get(handles.uitable1,'Data'); % We need the table to see what options people picked
   
    a.annotation.display_in_analysis = ones(1,size(data,1)+1);
    a.annotation.display_in_analysis = a.annotation.display_in_analysis * 1000;
    a.annotation.display_in_analysis(1,1) = 0; 
    for i = 2:size(data,1)+1
        if not(isnan(str2double(char(data(i-1,2)))))
            a.annotation.display_in_analysis(1,i) = str2double(char(data(i-1,2)));
        end     
        %end
    end    
    
    [a.annotation.display_in_analysis B] = sort(a.annotation.display_in_analysis);
    a.annotation.MiniGoTerms2  = handles.MiniGoTerms2(:,B);
    a.annotation.display = 1;
    for i = 2:size(a.annotation.display_in_analysis,2)
       if a.annotation.display_in_analysis(1,i) == 1000 
          
       else 
          a.annotation.display = a.annotation.display + 1;
       end
    end
    
    if (get(handles.checkbox1,'value') == 0) %is first row header, 0 = not 
        cols = size(a.annotation.MiniGoTerms2,2);
        temp = {};
        for i = 1:cols
           temp(1,i) = cellstr(sprintf('Column%i',i));  
        end
        temp(2:size(a.annotation.MiniGoTerms2,1)+1,:) = a.annotation.MiniGoTerms2;
        a.annotation.MiniGoTerms2 = temp;
        
    end
    
    
   save(sprintf('%s%s',pathname,filename),'-struct','a','annotation');
end

%% Useless callbacks


function statusBarText_Callback(hObject, eventdata, handles)

function statusBarText_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in checkbox1.
function checkbox1_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox1
