function varargout = gui_repository(varargin)
% GUI_REPOSITORY M-file for gui_repository.fig
%      GUI_REPOSITORY, by itself, creates a new GUI_REPOSITORY or raises the existing
%      singleton*.
%
%      H = GUI_REPOSITORY returns the handle to a new GUI_REPOSITORY or the handle to
%      the existing singleton*.
%
%      GUI_REPOSITORY('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GUI_REPOSITORY.M with the given input arguments.
%
%      GUI_REPOSITORY('Property','Value',...) creates a new GUI_REPOSITORY or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before gui_repository_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to gui_repository_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help gui_repository

% Last Modified by GUIDE v2.5 17-Aug-2010 11:26:43

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @gui_repository_OpeningFcn, ...
                   'gui_OutputFcn',  @gui_repository_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before gui_repository is made visible.
function gui_repository_OpeningFcn(hObject, eventdata, handles, varargin)

handles.output = hObject;
guidata(hObject, handles);


% --- Outputs from this function are returned to the command line.
function varargout = gui_repository_OutputFcn(hObject, eventdata, handles) 
varargout{1} = handles.output;


function noLogButton_Callback(hObject, eventdata, handles)
%Step 2 - No Log Button
set(handles.statusText,'ForeGroundColor','b');
set(handles.statusText,'String','Processing...');
pause(0.00001);
%gcrma

%Convert to numbers
raw = handles.Repository_Table(2:end,2:end);
nums = zeros(size(raw));
   for j = 1:size(raw,2) % Columns
       set(handles.statusText,'String',sprintf('Processing... Finding Numbers (Column %i of %i)',j,size(raw,2)));
       pause(0.00001);
       for i = 1:size(raw,1) % rows
           try
               temp = str2double(char(raw(i,j)));
           catch
               temp = 0;
           end
          if (length(temp) == 1) % Cell might not contain numbers safety check
             nums(i,j) = temp;
          end
       end
   end


handles.Repository.rawData = nums; % Raw copy of numerical data is stored.
handles.Repository.rawDataID = handles.Repository_Table(2:end,1); %First row is headers so start at 2nd row.
handles.Repository.rawColumnTitles = handles.Repository_Table(1,2:end); %First column is Affy IDs so skip
guidata(hObject, handles);

set(handles.logBase2Button,'Enable','Off');
set(handles.noLogButton,'Enable','Off');
set(handles.statusText,'ForeGroundColor','k');
set(handles.statusText,'String','Finished.');
set(handles.nameFinishButton,'Enable','On');
set(handles.repoNameText,'Enable','On');

function logBase2Button_Callback(hObject, eventdata, handles)
% Step 2 - Log Base 2 Button
set(handles.statusText,'String','Processing...');
set(handles.statusText,'ForeGroundColor','b');
pause(0.00001);
%mas5

%Convert to Numbers
raw = handles.Repository_Table(2:end,2:end);
nums = zeros(size(raw));
   for j = 1:size(raw,2) % Columns
       set(handles.statusText,'String',sprintf('Processing... Finding Numbers (Column %i of %i)',j,size(raw,2)));
       pause(0.00001);
       for i = 1:size(raw,1) % rows
           try
               temp = str2double(char(raw(i,j)));
           catch
               temp = 0;
           end
          if (length(temp) == 1)
             nums(i,j) = temp;
          end
       end
   end
% LOG BY BASE 2
handles.Repository.rawData = log2(nums); % Raw copy of numerical data is stored.
handles.Repository.rawData(handles.Repository.rawData == -Inf) = -5;
handles.Repository.rawDataID = handles.Repository_Table(2:end,1); %First row is headers so start at 2nd row.
handles.Repository.rawColumnTitles = handles.Repository_Table(1,2:end); %First column is Affy IDs so skip
guidata(hObject, handles);

set(handles.logBase2Button,'Enable','Off');
set(handles.noLogButton,'Enable','Off');
set(handles.statusText,'ForeGroundColor','k');
set(handles.statusText,'String','Finished.');
set(handles.nameFinishButton,'Enable','On');
set(handles.repoNameText,'Enable','On');

function importButton_Callback(hObject, eventdata, handles)
% Import Button - opens .csv table and then it creates the basis of a
% repository, as well as code to setup up the table for the column group
% selection step.
%
[filename, pathname] = uigetfile({'*.csv';'*.txt';'*.*'},'Select Normalized Raw Data file (in .CSV format) to load','../data/raw data/raw.txt');
if isequal(filename,0) || isequal(pathname,0)
else
    set(handles.statusText,'String','Opening File...');
    set(handles.statusText,'ForeGroundColor','b');
    pause(0.00001);
    fid = fopen(strcat(pathname,filename));
    tline = fgetl(fid);
  %Initially we are determing the size
  % The code looks somewhat complex to the fact that csv format also has a
  % clause that if a comma exists inside a cell it then puts "s around
  % the cell, and this needs to be taken into account in both counting
  % columns and the actualy processing
  %First count how columns are in the first line
    requiredColumns = 0;
    remaining = tline;
    across = 1;
    ignoring = 0;
    set(handles.statusText,'String','Opening File... (Counting Columns)');
    pause(0.00001);
    while(size(remaining,2) > 1)           
        for j = 1:(size(remaining,2))
            if ignoring == 1
                if strcmp(remaining(j),'"')
                    if j+1 < (size(remaining,2))
                        if strcmp(remaining(j+1),','), ignoring = 0; end;
                    end
                end
            else
                if j == 1 && strcmp(remaining(1),'"'), ignoring = 1; end;
                if strcmp(remaining(j),',')
                    if strcmp(remaining(j+1),'"'),ignoring = 1; end;
                    requiredColumns = requiredColumns + 1;
                    remaining = remaining((j + 1):end);
                    across = across + 1;
                    break;
                end 
            end
            if j == size(remaining,2)
               %copy this off
                requiredColumns = requiredColumns + 1;
               remaining = '';
            end
        end
    end
   set(handles.statusText,'String','Opening File... (Counting Rows)');
   pause(0.00001);
    lineCount = 1; % Line count starts as one as we just parsed the column count from the first row.
    while ischar(tline),  lineCount = lineCount +1; tline = fgetl(fid);   end; % Count Up the Lines
   Repository_Table = cell(lineCount-1,requiredColumns);
   fclose(fid);
   fid = fopen(strcat(pathname,filename));
   curCount = 1;
   tline = fgetl(fid);
   while ischar(tline)
       if mod(curCount,250) == 0
               set(handles.statusText,'String',sprintf('Parsing File... (Line %i of %i)',curCount,lineCount));
             pause(0.00001);
       end
    remaining = tline;
    across = 1;
    ignoring = 0;
    while(size(remaining,2) > 0)                
        for j = 1:(size(remaining,2))
            if ignoring == 1
                if strcmp(remaining(j),'"')
                    if j+1 < (size(remaining,2))
                        if strcmp(remaining(j+1),','),  ignoring = 0;   end;
                    end               
                end
            else
                if j == 1 && strcmp(remaining(1),'"'),  ignoring = 1;   end;
                if strcmp(remaining(j),',')
                    if strcmp(remaining(j+1),'"'), ignoring = 1; end;
                     if strcmp(remaining(1),'"') && strcmp(remaining(j-1),'"')
                        Repository_Table(curCount,across) = {remaining(2:(j - 2))};
                     else
                        Repository_Table(curCount,across) = {remaining(1:(j - 1))};
                    end
                    remaining = remaining((j + 1):end);
                    across = across + 1;
                    break;
                end 
            end
            if j == size(remaining,2)
               %copy this off
               Repository_Table(curCount,across) = {remaining(1:end)};
               remaining = '';
            end
        end
    end
    curCount = curCount +1;
    tline = fgetl(fid);
   end
fclose(fid);
%Data collected
set(handles.statusText,'String','Processing... (Sorting Rows)');
pause(0.00001);
    
set(handles.saveCommentsButton,'Enable','Off');
set(handles.importButton,'Enable','Off');
set(handles.saveButton,'Enable','Off');

set(handles.uitable1,'Enable','On');
set(handles.doneButton,'Enable','On');
set(handles.popupmenu1,'Enable','On');
set(handles.popupmenu1,'String',1:(size(Repository_Table,2)-1));
% -1 for Affy IDs

val = get(handles.popupmenu1,'Value');


% Column one
data(:,1) = Repository_Table(1,2:end);
data(:,2) = cellstr(num2str(ones(size(Repository_Table(1,2:end),1))));

String = cell(1,val);%{'1','2','3'};
for i = 1:val
String(i) = num2cell(i);    
end

sstring = 'set(handles.uitable1,''ColumnFormat'',{''char'',{ ''Comment'' ''Forget'' ';
for i = 1:val
    sstring = sprintf('%s''%i'' ',sstring,i);
end
sstring = strcat(sstring,'}});');
eval(sstring);

set(handles.uitable1,'ColumnName',{'Column Name' , 'Group'});
set(handles.uitable1,'ColumnEditable', [ true true] );
set(handles.uitable1,'Data',data);
set(handles.uitable1,'ColumnWidth',{250, 'auto'});

end % end of if filename/dirname selected

   [new newi] = sort(Repository_Table(2:end,1));
   Repository_Table(2:end,:) = Repository_Table(newi+1,:);

handles.Repository_Table = Repository_Table;
guidata(hObject, handles);

set(handles.statusText,'ForeGroundColor','k');
set(handles.statusText,'String','Loaded. Please do Step 2');
set(handles.repoNameText,'String',filename);


% --- Executes on selection change in popupmenu1.
function popupmenu1_Callback(hObject, eventdata, handles)
%popupmenu1 is the popmenu that specifys how many groups there are.
%This changes the contents of the UI table,
val = get(hObject,'Value');

oldata = get(handles.uitable1,'Data');
% First column contains contents the headres of the repository with affy ID
% column removed
data(:,1) = handles.Repository_Table(1,2:end);
% Initalize 2nd column
data(:,2) = cellstr(num2str(ones(size(handles.Repository_Table(1,2:end),1))));
% SUGGEST 2nd column defaults
%Loop through data text data = comments?


indexNums = [];
for i = 1:size(handles.Repository_Table(2,:),2)-1
     try
         if (strcmp(char(oldata(i,2)),'Comment')) || (strcmp(char(oldata(i,2)),'Forget'))
             data(i,2) = oldata(i,2);
         else
            if (isnan(str2double(char(handles.Repository_Table(2,i+1)))))
               data(i,2) = cellstr('Comment');    
            else
               indexNums(size(indexNums,1)+1,1) = i;
            end
         end
     catch
        data(i,2) = cellstr('Comment');
     end
end
if size(indexNums,1) == 0
    disp('-----------------------');
    disp('Error, 2nd Column is all text, delete in excel and reimport');
    disp('-----------------------');
    return;
end
if mod(size(indexNums,1),val) == 0
    si = size(indexNums,1) / val;
   for i = 1:val
       toProcess = indexNums(i*si - si + 1:i*si);
       for j = 1:size(toProcess,1)
       data(toProcess(j),2) = cellstr(num2str(i));
       end
   end
end






% little bit of advanced code which quite simply turns the 2nd column into
% a drop down menu for every cell in the 2nd column ranging from
% Comment,Forget and the numbers in the group
sstring = 'set(handles.uitable1,''ColumnFormat'',{''char'',{ ''Comment'' ''Forget'' ';
for i = 1:val
    sstring = sprintf('%s''%i'' ',sstring,i);
end
sstring = strcat(sstring,'}});');
eval(sstring);
% Set Table options
set(handles.uitable1,'ColumnName',{'Column Name' , 'Group'});
set(handles.uitable1,'ColumnEditable', [ true true] );
set(handles.uitable1,'Data',data);
set(handles.uitable1,'ColumnWidth',{250, 90});



% --- Executes on button press in saveButton.
function saveButton_Callback(hObject, eventdata, handles)
% Save Button - yes it saves the data off as well as organizing the groups
% into order and calculating their means
set(handles.statusText,'String','Processing... Organizing Columns');
pause(0.0001);
data = get(handles.uitable1,'Data'); % We need the table to see what options people picked
val = get(handles.popupmenu1,'Value'); % How many groups are there
%each group
aCol = 1;

groupSize = zeros(val,1);
handles.temp.rawData = []; % Can't do this incase of zero columns
%Sort the groups into the correct order.
for i = 1:val
    selector = strcmp(data(:,2),num2str(i));
   groupSize(i) = sum(selector);
   
   handles.temp.rawData(:,aCol:(aCol+(groupSize(i)-1))) = handles.Repository.rawData(:,selector);
   handles.temp.rawColumnTitles(:,aCol:(aCol+(groupSize(i)-1))) = handles.Repository.rawColumnTitles(:,selector);
   aCol = aCol + groupSize(i);
end
%Construct the Repository gorup.
handles.Repository.rawData = handles.temp.rawData;
handles.Repository.rawColumnTitles = handles.temp.rawColumnTitles;
handles.Repository.groupSize = groupSize;
handles.Repository.groups = val;
handles.Repository.name = get(handles.repoNameText,'String');
handles.Repository.notes = get(handles.notesText,'String');


set(handles.statusText,'String','Calculating Group Means...');
pause(0.0001);
handles.Repository.meanData = zeros(size(handles.Repository.rawData,1),handles.Repository.groups);
for i = 1:val % loop through columns
    set(handles.statusText,'String',sprintf('Calculating Group Means... (%i of %i)',i,size(handles.Repository.meanData,2)));
    pause(0.0001);
    starti = sum(groupSize(1:i-1))+1;
    handles.Repository.meanColumns(1,i) = handles.Repository.rawColumnTitles(1,starti);
    for j = 1:size(handles.Repository.rawData,1)
        handles.Repository.meanData(j,i) = mean(handles.Repository.rawData(j,starti:(starti + (groupSize(i)-1))));
        % start from sum of all previous columns
    end
end
set(handles.statusText,'String','Processed. Choose place to save.');

[filename, pathname] = uiputfile('*.mat','Save Repository',strcat('../data/repositories/',get(handles.repoNameText,'String'),'-Repository.mat'));
if isequal(filename,0) || isequal(pathname,0)
else
   save(sprintf('%s%s',pathname,filename),'-struct','handles','Repository');
end

set(handles.importButton,'Enable','On');

set(handles.statusText,'String','Saved. Either start from step 1 again or quit.');
%% Op

% Save

guidata(hObject, handles);






% --- Executes on button press in saveCommentsButton.
function saveCommentsButton_Callback(hObject, eventdata, handles)
% saveCommentsButton - Saves the comments into a transcription table for use in the Analyse part
% of the program

%%%%%% DEBUG
data = get(handles.uitable1,'Data');
selector = false;
selector(2:size(data,1)+1,1) = strcmp(data(:,2),'Comment');
assignin('base','data',data);
assignin('base','Repository_Table',handles.Repository_Table);
%%%%%% DEBUG

%Headers
%Assemble table data struct
% Cell
Transcription_Table = {};
Transcription_Table(1,1) = cellstr('AffyMetrix ID');
% Affy IDs
Transcription_Table(2:size(handles.Repository_Table(2:end,1))+1,1) = handles.Repository_Table(2:end,1);
% Column headers of the selected.
Transcription_Table(1,2:sum(selector)+1) = handles.Repository_Table(1,selector);
% data from said columns
Transcription_Table(2:size(handles.Repository_Table,1),2:sum(selector)+1) = handles.Repository_Table(2:end,selector);
    [filename, pathname] = uiputfile('*.mat','Save Comments',strcat('../data/libraries/',get(handles.repoNameText,'String'),'-Supplement.mat'));
    if isequal(filename,0) || isequal(pathname,0)

    else
       save(sprintf('%s%s',pathname,filename),'Transcription_Table');
    end


% --- Executes on button press in doneButton.
function doneButton_Callback(hObject, eventdata, handles)
% doneButton - this terminates the column group picking step
% and mainly just enables/disables button to mark end of a step.
set(handles.repoNameText,'Enable','Off');
set(handles.saveCommentsButton,'Enable','Off');
set(handles.uitable1,'Enable','Off');
set(handles.doneButton,'Enable','Off');
set(handles.popupmenu1,'Enable','Off');

set(handles.logBase2Button,'Enable','On');
set(handles.noLogButton,'Enable','On');


% --- Executes on button press in nameFinishButton.
function nameFinishButton_Callback(hObject, eventdata, handles)
% nameFinishButton - this terminates the naming picking step and will then
% setup the varibles for for the prefix filtering step
set(handles.affyText,'String',char(handles.Repository.rawDataID(1,1)));
set(handles.textOrginal,'String',char(handles.Repository.rawDataID(1,1)));

set(handles.nameFinishButton,'Enable','Off');
set(handles.repoNameText,'Enable','Off');
set(handles.affyid_Button,'Enable','On');
set(handles.affyText,'Enable','On');

% --- Executes on button press in affyid_Button.
function affyid_Button_Callback(hObject, eventdata, handles)
%affyid_Button - handles the filtering of of the affy ID column it will
%remove a prefix if one has been specified
string = get(handles.affyText,'String');

if (~isempty(string))
    set(handles.statusText,'String','Processing... AffyIDs');
    pause(0.0001);
    l = length(string);
    %Do the already done repostiory Affy IDs
    for i = 1:size(handles.Repository.rawDataID,1)
        if mod(i,2000) == 0
            set(handles.statusText,'String',sprintf('Processing... AffyIDs (%i of %i)',i,size(handles.Repository.rawDataID,1)));
            pause(0.0001);
        end;
       thisString =  char(handles.Repository.rawDataID(i,1));
       handles.Repository.rawDataID(i,1) = cellstr(thisString(l+1:end));
    end
    % Do for the table for the comments
    for i = 1:size(handles.Repository_Table,1)
        if mod(i,2000) == 0
            set(handles.statusText,'String',sprintf('Processing... AffyIDs *2 (%i of %i)',i,size(handles.Repository.rawDataID,1)));
            pause(0.0001);
        end;

       thisString =  char(handles.Repository_Table(i,1));
       handles.Repository_Table(i,1) = cellstr(thisString(l+1:end));
    end
    %remove length of characters from being
    set(handles.statusText,'String','Finished now Save.');
    pause(0.0001);
end;

set(handles.affyid_Button,'Enable','Off');
set(handles.saveButton,'Enable','On');
set(handles.affyText,'Enable','Off');
set(handles.saveCommentsButton,'Enable','On');

guidata(hObject, handles);


%% Useless code - Below
%
% This only exists to improve performance, as it will make it findable.
%
function statusText_Callback(hObject, eventdata, handles)

function statusText_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function repoNameText_Callback(hObject, eventdata, handles)

function repoNameText_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function popupmenu1_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function affyText_Callback(hObject, eventdata, handles)

function affyText_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function notesText_CreateFcn(hObject, eventdata, handles)

function notesText_Callback(hObject, eventdata, handles)
