function varargout = gui_study(varargin)
% GUI_STUDY M-file for gui_study.fig
%      GUI_STUDY, by itself, creates a new GUI_STUDY or raises the existing
%      singleton*.
%
%      H = GUI_STUDY returns the handle to a new GUI_STUDY or the handle to
%      the existing singleton*.
%
%      GUI_STUDY('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GUI_STUDY.M with the given input arguments.
%
%      GUI_STUDY('Property','Value',...) creates a new GUI_STUDY or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before gui_study_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to gui_study_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help gui_study

% Last Modified by GUIDE v2.5 17-Aug-2010 14:02:47

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @gui_study_OpeningFcn, ...
                   'gui_OutputFcn',  @gui_study_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before gui_study is made visible.
function gui_study_OpeningFcn(hObject, eventdata, handles, varargin)

handles.output = hObject;
guidata(hObject, handles);


% --- Outputs from this function are returned to the command line.
function varargout = gui_study_OutputFcn(hObject, eventdata, handles) 
varargout{1} = handles.output;


% --- Executes on button press in loadRepoButton.
function loadRepoButton_Callback(hObject, eventdata, handles)
% loadRepoButton - loads a repository from a box displayed to the user
% Load Button pressed
%pop up the lovely user interface get file box with a suggested file (which
%   puts the user in that directory)
[filename, pathname] = uigetfile({'*.mat';'*.*'},'Select Repository file to load','../data/repositories/Repository.mat');
if isequal(filename,0) || isequal(pathname,0)
else
  a = load(strcat(pathname,filename));
  handles.Repository = a.Repository;

    handles.Study.AffyIDs = handles.Repository.rawDataID;
    handles.Study.data = handles.Repository.meanData;
    handles.Study.ColumnIDs = handles.Repository.meanColumns;
    handles.Study.groups = handles.Repository.groups;
    handles.Study.groupSize = handles.Repository.groupSize;
    handles.Study.name = handles.Repository.name;
    
    try
        set(handles.repoNotesText,'String',handles.Repository.notes);
    catch
    end
    
    guidata(hObject, handles);
    set(handles.thresholdStatus,'String','Loaded.');
    set(handles.remainingGenes,'String',sprintf('Genes Remaining: %i',size(handles.Study.data,1)));
    set(handles.repoNameText,'String',sprintf('Repository: %s',handles.Repository.name));
    set(handles.skip1Button,'Enable','On');
    set(handles.thresholdButton,'Enable','On');
    set(handles.thresholdApproveButton,'Enable','Off');
    set(handles.noFilterSave,'Enable','On');
    set(handles.saveStudyButton,'Enable','Off');
    set(handles.slider1,'Enable','Off');
    set(handles.slider2,'Enable','Off');
    set(handles.step2DO_Button,'Enable','Off');
    set(handles.fscoreSpliceButton,'Enable','Off');
    set(handles.fscoreTextVal,'Enable','Off');
end

% --- Executes on button press in saveStudyButton.
function saveStudyButton_Callback(hObject, eventdata, handles)
%saveStudyButton - will save off the study and make a directory for studies
%from that repository if it doesn't exist.
if (not(exist(strcat('../data/studies/',handles.Study.name))))
    %If folder doesnt exist for the study make one!
mkdir('../data/studies/',handles.Study.name);
end
[filename, pathname] = uiputfile('*.mat','Save Study',strcat('../data/studies/',handles.Study.name,'/',handles.Study.name,'-',num2str(size(handles.Study.data,1)),'Genes-Study.mat'));
if isequal(filename,0) || isequal(pathname,0)
     % Error expected if folder has contents, this was only added to
     % remove, blank folders
     try
    rmdir(strcat('../data/studies/',handles.Study.name));
    catch
    end
else
    try
    handles.Study.repoNotes = handles.Repository.notes;
    catch
       handles.Study.repoNotes = ''; 
    end
    handles.Study.studyNotes = get(handles.studyNotesText,'String');
   save(sprintf('%s%s',pathname,filename),'-struct','handles','Study');
end

% --- Executes on button press in skip1Button.
function skip1Button_Callback(hObject, eventdata, handles)
%skip1Button - use to skip step 1 (Threshold step)
%
    handles.Study.raw = handles.Repository.rawData;
    handles.Study.Filter_Threshold = 'Skipped';
    set(handles.skip1Button,'Enable','Off');
    set(handles.thresholdButton,'Enable','Off');
    set(handles.thresholdApproveButton,'Enable','Off');
    set(handles.slider2,'Enable','Off');
    set(handles.step2DO_Button,'Enable','On');
    set(handles.noFilterSave,'Enable','Off');
    guidata(hObject, handles);

% --- Executes on slider movement.
function slider1_Callback(hObject, eventdata, handles)
%slider1 is the slider for step 2 (F-Scores) as it was created first
% This code here changes the text to show the user how many are left and value in the text box
val = get(hObject,'Value');

above = sum( handles.Study.std_ratios > val);
string = sprintf('Value: %0.5f Genes that would remain: %i',val,above);
set(handles.fscoreStatus,'String',string);
set(handles.fscoreTextVal,'String',num2str(val));

function fscoreTextVal_Callback(hObject, eventdata, handles)
% fscoreTextVal - text box next to slider 2 - stores the value of the
% slider so the user can read the exact value or specify an exact value
% Called when the user does anything to the text
% This code changes the value of the slider and ensures it is within the
% limits
s = handles.slider1;
num = str2double(get(hObject,'String'));
min = get(s,'Min');
max = get(s,'Max');
if num > max, num = max; end;
if num < min, num = min; end;
set(s,'Value',num);
set(hObject,'String',sprintf('%.4f',num));
slider1_Callback(handles.slider1, 0, handles);

% --- Executes on button press in step2DO_Button.
function step2DO_Button_Callback(hObject, eventdata, handles)
% Step2DO - plots the F-Score histogram and unlocks the controls to play with
% (button/textbox/slider)
set(handles.fscoreStatus,'String','Processing');
pause(0.001);
handles.Study.raw_row_stds = std( handles.Study.raw, 1, 2 ); 
handles.Study.row_stds = std(   handles.Study.data, 1, 2 ); 
% the higher the std_ratio, the greater the fraction of variance that is
% between-group rather than within-group
handles.Study.std_ratios = handles.Study.row_stds ./ ( handles.Study.raw_row_stds + mean(handles.Study.raw_row_stds)/10); 
% the maximum possible value of this is approximately 1
% adding mean(row_stds)/10 to the denominator ensures a slight positive
% bias towards genes with high variance of expression.

%% Filtrate Based on F-Scores

% always visualise 
axes(handles.axes1); % makes the active plot (current axis)
hist( handles.Study.std_ratios, 30 )
% this code adjusts the axis to be 0->1 across the bottom
t = get(gca,'CameraPosition');
axis ([0 1 0 (t(2) * 2)]);
guidata(hObject, handles);

val = get(handles.slider1,'Value');

above = sum( handles.Study.std_ratios > val);
string = sprintf('Value: %0.5f Genes that would remain: %i',val,above);
set(handles.fscoreStatus,'String',string);
set(handles.slider1,'Enable','On');
set(handles.step2DO_Button,'Enable','Off');
set(handles.fscoreSpliceButton,'Enable','On');
set(handles.fscoreTextVal,'String',num2str(val));
set(handles.fscoreTextVal,'Enable','On');

% --- Executes on button press in fscoreSpliceButton.
function fscoreSpliceButton_Callback(hObject, eventdata, handles)
% fscoreSpliceButton - this code filters out the remaining gene based on
% the select fscore value
%
selector = handles.Study.std_ratios > get(handles.slider1,'Value');
set(handles.remainingGenes,'String',sprintf('Genes Remaining: %i',sum(selector)));

handles.Study.AffyIDs = handles.Study.AffyIDs(selector);
handles.Study.data = handles.Study.data(selector,:);
handles.Study.raw = handles.Study.raw(selector,:);
handles.Study.raw_row_stds = handles.Study.raw_row_stds(selector);
handles.Study.row_stds = handles.Study.row_stds(selector);
handles.Study.std_ratios = handles.Study.std_ratios(selector);
handles.Study.Filter_Fscore = sprintf('%d',get(handles.slider1,'Value'));
handles.Study.data_z_scores = normalise_row_sds( handles.Study.data ); 
handles.Study.zero_means = zero_mean_rows(handles.Study.data);
handles.Study.foldInduction = fold_induction(handles.Study.data);
handles.Study.percentInduction = percent_induction(handles.Study.data);
guidata(hObject, handles);



set(handles.saveStudyButton,'Enable','On');


% --- Executes on button press in thresholdButton.
function thresholdButton_Callback(hObject, eventdata, handles)
% thresholdButton - this is the button which calculates the thresholds and
% then plots a histogram of many genes would fail at said point. as well as
% putting in a inital threshold in the middle for the slider.


%plot a histogram of result distribution?
axes(handles.axes2);
%hist(handles.Repository.rawData);
set(handles.thresholdStatus,'String',sprintf('Counted ( 0 of %i )',size(handles.Study.data,1)));

%% NOW UPDATING TO NON TRIPLICATE VALUES
% Initalize variable to store the minimum number a gene/probe will fail for all
handles.thresholdInfo = zeros(size(handles.Repository.rawData,1),1);
for i = 1:size(handles.Study.data,1) % loop through rows
    if (mod(i,1000) == 0)
        set(handles.thresholdStatus,'String',sprintf('Counted ( %i of %i )',i,size(handles.Study.data,1)));
        pause(0.001);
        %fprintf('Counted %i of %i ...\n',i,size(handles.Study.data,1));
    end
    minimums = zeros(handles.Study.groups,1);
    %loop through groups
    for j = 1:handles.Study.groups
        gs = handles.Study.groupSize(j); % group size
      groupValues = handles.Repository.rawData(i,j*gs-(gs-1):j*gs);
       minsRequired = round(gs/2);
       mins = zeros(minsRequired,1);
       for k = 1:minsRequired
           mins(k) = min(groupValues);
           % filter out the minimum Value
           filter = true(size(groupValues));
           for l = 1:size(groupValues)
                if groupValues(l) == mins(k)
                    filter(k) = 0;
                    groupValues = groupValues(filter);
                    break;
                end
           end
       end
       % minimum fail value for this triplicate
       minimums(j) = max(mins);
    end
    % post triplicate processing
    handles.thresholdInfo(i) = max(minimums);
end
set(handles.thresholdStatus,'String',sprintf('Counted %i of %i ...\n',i,size(handles.Study.data,1)));
hist(handles.thresholdInfo);
guidata(hObject, handles);
%edit slider to work with axis
maxa = max(handles.thresholdInfo);
mina = min(handles.thresholdInfo);
set(handles.slider2,'Max',maxa);
set(handles.slider2,'Value',mean([maxa mina]));
set(handles.slider2,'Min',mina);
val = get(handles.slider2,'Value');

above = sum( handles.thresholdInfo > val);
string = sprintf('Value: %0.5f Genes that would remain: %i',val,above);
set(handles.thresholdStatus,'String',string);

set(handles.slider2,'Enable','On');
set(handles.thresholdTextVal,'Enable','On');
set(handles.thresholdTextVal,'String',num2str(val));
set(handles.thresholdApproveButton,'Enable','On');
set(handles.thresholdButton,'Enable','Off');

% --- Executes on slider movement.
function slider2_Callback(hObject, eventdata, handles)
%Slider 2 - the slider under the threshold plot
% On slider movement this will readjust the genes remaining as well as the
% value displayed in both the text box and the 'status text box'
val = get(hObject,'Value');

above = sum( handles.thresholdInfo > val);
string = sprintf('Value: %0.5f Genes that would remain: %i',val,above);
set(handles.thresholdStatus,'String',string);
set(handles.thresholdTextVal,'String',num2str(val));


function thresholdTextVal_Callback(hObject, eventdata, handles)
% thresholdTextVal - is the text box next to slider 2, this has the exact
% value of the threshold stored in it, the user may change the value, which
% is what this hook takes care of, and ensures the value is within the
% limits
s = handles.slider2;
num = str2double(get(hObject,'String'));
min = get(s,'Min');
max = get(s,'Max');
if num > max, num = max; end;
if num < min, num = min; end;
set(s,'Value',num);
set(hObject,'String',sprintf('%.4f',num));
slider2_Callback(handles.slider2, 0, handles);


% --- Executes on button press in thresholdApproveButton.
function thresholdApproveButton_Callback(hObject, eventdata, handles)
%thresholdApproveButton - this button is for when the user approves the
% threshodld cutoff value, this code will then complete it and filter the
% data.
val = get(handles.slider2,'Value');

selector = handles.thresholdInfo > val;

handles.Study.raw = handles.Repository.rawData(selector,:);
handles.Study.data = handles.Study.data(selector,:);
handles.Study.AffyIDs = handles.Study.AffyIDs(selector,:);
handles.Study.Filter_Threshold = sprintf('%d',val);

set(handles.remainingGenes,'String',sprintf('Genes Remaining: %i',size(handles.Study.raw,1)));
guidata(hObject, handles);

 set(handles.skip1Button,'Enable','Off');
 set(handles.thresholdButton,'Enable','Off');
 set(handles.thresholdTextVal,'Enable','Off');
 set(handles.thresholdApproveButton,'Enable','Off');
 set(handles.slider2,'Enable','Off');
 set(handles.step2DO_Button,'Enable','On');
 set(handles.noFilterSave,'Enable','Off');

% --- Executes on button press in noFilterSave.
function noFilterSave_Callback(hObject, eventdata, handles)
%noFilterSave - is the button designed to save of all the data preserving
%it all, and not filtering anything, say for SAM files.
%
handles.Study.raw = handles.Repository.rawData;
handles.Study.raw_row_stds = std( handles.Study.raw, 1, 2 ); 
handles.Study.row_stds = std(   handles.Study.data, 1, 2 ); 
handles.Study.Filter_Fscore = 'Skipped';
handles.Study.Filter_Threshold = 'Skipped';
handles.Study.repoNotes = handles.Repository.notes;
handles.Study.studyNotes = get(handles.studyNotesText,'String');
% row_stds BECAME raw_Row stds
% group_row_stds BECAMSE row_stds

% the higher the std_ratio, the greater the fraction of variance that is
% between-group rather than within-group
handles.Study.std_ratios = handles.Study.row_stds ./ ( handles.Study.raw_row_stds + mean(handles.Study.raw_row_stds)/10);
handles.Study.data_z_scores = normalise_row_sds( handles.Study.data ); 
handles.Study.zero_means = zero_mean_rows(handles.Study.data);
handles.Study.foldInduction = fold_induction(handles.Study.data);
handles.Study.percentInduction = percent_induction(handles.Study.data);

guidata(hObject, handles);
if (not(exist(strcat('../data/studies/',handles.Study.name))))
mkdir('../data/studies/',handles.Study.name);
end
[filename, pathname] = uiputfile('*.mat','Save Study',strcat('../data/studies/',handles.Study.name,'/',handles.Study.name,'-',num2str(size(handles.Study.data,1)),'Genes-Study.mat'));
if isequal(filename,0) || isequal(pathname,0)
     % Error expected if folder has contents, this was only added to
     % remove, blank folders
     try
    rmdir(strcat('../data/studies/',handles.Study.name));
    catch
    end
else
   save(sprintf('%s%s',pathname,filename),'-struct','handles','Study');
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%%      USELESSS CODE BELOW
% it exists here as I believe missing functions will slow it down.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function statusText_Callback(hObject, eventdata, handles)

function statusText_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function remainingGenes_Callback(hObject, eventdata, handles)

function remainingGenes_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function repoNameText_Callback(hObject, eventdata, handles)

function repoNameText_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function slider2_CreateFcn(hObject, eventdata, handles)
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

function thresholdStatus_Callback(hObject, eventdata, handles)

function thresholdStatus_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function fscoreStatus_Callback(hObject, eventdata, handles)

function fscoreStatus_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function slider1_CreateFcn(hObject, eventdata, handles)
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

function fscoreTextVal_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function thresholdTextVal_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function repoNotesText_Callback(hObject, eventdata, handles)

function repoNotesText_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function studyNotesText_Callback(hObject, eventdata, handles)

function studyNotesText_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
