function nsdm = normalise_row_sds( mat )
% returns a matrix with rows that have zero mean and normalised sd
% sd is calculated dividing by n rather than n-1

zmat = zero_mean_rows( mat ); 

sds = std( zmat, 1, 2 ); 

isds = 1 ./ ( sds + 1.0e-10 ); 

nsdm = zmat; 
for c = 1:size(nsdm,2)
    nsdm(:,c) = nsdm(:,c) .* isds; 
end

end