function dd = pairwise_robust_distances( X, w ) 
% returns a square matrix of distances between different rows of X
% 

[N C] = size( X ); 
Xprime = X'; 

dd = zeros( N , N ); 

%pdisthandle = @(u,v)(pdistance( u, v, p ) ); 


for r = 1:N-1
    absdiff = abs( bsxfun( @minus, Xprime(:,r), Xprime(:,r+1:end)) );
    absdiffsq =  (absdiff .^ 2);
    filter = absdiff < w; 
    dd(r, r+1:end) = ( (1/(2 * w)) * sum( filter .* absdiffsq ) + sum( (1-filter) .* (absdiff - (w/2))) );
end
dd = dd + dd'; % symmetrises the distances, which may be unnecessary. 

end