function patch_list_out = patches_at_level( patch_root, level, patch_list_in )
% returns an column vector of cells containing the patchspecs at level
% root is at level zero

if nargin == 2 % default used in top-level call
    patch_list_in = {};
end

if level == 0 
    newcell = cell( 1, 1); 
    newcell{1} = patch_root; 
    patch_list_out = [ patch_list_in ; patch_root ];
else
    children = patch_root.children; 
    patch_list_out = patch_list_in; 
    for cx = 1:length( children )
        patch_list_out = patches_at_level( children{cx}, level - 1, patch_list_out ); 
    end
end

end

