% script  for doing everything


%  zscores -- the zscores used for the tsne 

% like the tsne we have been doing....
% tspts_white = tsne( zscores, ones( size(zscores,1)), 2, 5, ... % change 5 to a suitable number
%    30, true );  % true means with whitening

% tsneData = tsne( zscores, ones( size(zscores,1)), 2, 5, ... % change 5 to a suitable number
%    30, false );  % false means without whitening

zscores = Study.data_z_scores;
pcproj = pcs_of_z_scores( zscores ); 

%%% qq is verleysen's Q statistic, bb is verleysen's B statistic
% mhv_****  is median rank of high vs visualisation (x axis is
%           visualisation neighbour rank
% mvh_****  is the other way round.  X axis is hd neighbour rank, y is 
%           median rank in visualisation


[ qq_tsneData bb_tsneData crh_tsneData mhv_tsneData mvh_tsneData ]...
    = co_rank_criterion( zscores, tsneData ); 
%[ qq_tspts_white bb_tspts_white crh_tspts_white mhv_tspts_white mvh_tspts_white ]...
%    = co_rank_criterion( zscores, tspts_white ); 

[ qq_pc  bb_pc  crh_pc mhv_pc mvh_pc ]...
    = co_rank_criterion( zscores, pcproj(:,1:2) ); 

x = [1:250];
y = [1:250];

figure
f = plot( qq_tsneData, 'b','LineWidth', 3);
get(gcf)
get(gca)
get(f)
axis([1 100 0 0.8]);
set(gca, 'LineWidth', 2)
set(gca,'fontsize', 20);
set(gca,'fontweight', 'bold');
hold on
%plot( bb_tsneData, 'b');
%plot( qq_tspts_white, 'g'); 
%plot( bb_tspts_white, 'g'); 
plot( qq_pc, 'r','LineWidth', 3); 
%plot( bb_pc, 'r');
hold off

figure
g = plot (x, y, 'k--','LineWidth', 3);
get(gcf)
get(gca)
get(g)
axis([1 100 1 100]);
set(gca, 'LineWidth', 2)
set(gca,'fontsize', 20);
set(gca,'fontweight', 'bold');
hold on
plot( mhv_tsneData,'b','LineWidth', 3);
plot( mvh_tsneData, 'c','LineWidth', 3);
%plot( mhv_tspts_white, 'g'); 
%plot(mvh_tspts_white, 'c'); 
plot( mhv_pc, 'r','LineWidth', 3); 
plot( mvh_pc, 'm','LineWidth', 3);
plot (x, y, 'k:','LineWidth', 2);
hold off

figure
h = plot (x, y, 'k--','LineWidth', 3);
get(gcf)
get(gca)
get(h)
axis([1 250 1 250]);
set(gca, 'LineWidth', 2)
set(gca,'fontsize', 20);
set(gca,'fontweight', 'bold');
hold on
plot( mhv_tsneData,'b','LineWidth', 3);
plot( mvh_tsneData, 'c','LineWidth', 3);
%plot( mhv_tspts_white, 'g'); 
%plot(mvh_tspts_white, 'c'); 
plot( mhv_pc, 'r','LineWidth', 3); 
plot( mvh_pc, 'm','LineWidth', 3);
plot (x, y, 'k--','LineWidth', 2);
hold off

% neighbour_plots
%figure; 
%neighbour_plot( tspts_white, zscores );
%hold on
%plot( tspts_white(:,1), tspts_white(:,2), '.')
%hold off


%figure; 
%neighbour_plot( tsneData, zscores );  % should be 'better'

%figure;
%neighbour_plot( 20 * pcproj(:,1:2), zscores ); 

% plotting the co-rank histograms
% need to bin them first because they are huge,so will not plot smoothly
% otherwise



%evaluate from here, 
cq = cumsum2( crh_tsneData ); 
qbinned = decumulate2( cq( 19:20:end, 19:20:end) );
figure
logsurf = log10(crh_tsneData(1:30, 1:30)); 
s = surf( logsurf );
get(gcf)
get(gca)
get(s)
axis([1 30 1 30]);
set(gca, 'LineWidth', 2)
set(gca,'fontsize', 20);
set(gca,'fontweight', 'bold');
xlabel( 'D-space neighbor ranks' ); 
ylabel( 't-SNE neighbor ranks');

%maxheight= max( logsurf(:)); % to equalise colormaps

%figure; surf( qbinned )
%%%%%%%%%%%%%%%%% to here

%evaluate from here, 
%cq = cumsum2( crh_tsneData ); 
%qbinned = decumulate2( cq( 19:20:end, 19:25:end) );

%figure
%surf( log10(qbinned +0.5))

%figure; surf( qbinned )
%clear cq qbinned
%%%%%%%%%%%%%%%%% to here


%evaluate from here, 
figure
logsurf = log10(crh_pc(1:30, 1:30)); 
t = surf( logsurf )
get(gcf)
get(gca)
get(t)
axis([1 30 1 30]);
set(gca, 'LineWidth', 2)
set(gca,'fontsize', 20);
set(gca,'fontweight', 'bold');
xlabel( 'D-space neighbor ranks' ); 
ylabel( 'PCA neighbor ranks');


%cq = cumsum2( crh_pc ); 
%qbinned = decumulate2( cq( 19:20:end, 19:25:end) );

%figure
%surf( log10(qbinned +0.5))
%hold on
%surf( [0 1 ], [ 0 1 ], maxheight * ones( 2, 2)); 
%hold off
%figure; surf( qbinned )
%clear cq qbinned
%%%%%%%%%%%%%%%%% to here

%%%%%%%%%%%%%% try just one graph
%K = 15;
%figure
%surf( crh_tsneData(1:K,1:K) ./ crh_pc(1:K,1:K) ); 

