% script  for doing everything


%  zscores -- the zscores used for the tsne 

% like the tsne we have been doing....
tspts_white = tsne( zscores, ones( size(zscores,1)), 2, 5, ... % change 5 to a suitable number
    30, true );  % true means with whitening

tspts_raw = tsne( zscores, ones( size(zscores,1)), 2, 5, ... % change 5 to a suitable number
    30, false );  % false means without whitening

pcproj = pcs_of_z_scores( zscores ); 

%%% qq is verleysen's Q statistic, bb is verleysen's B statistic
% mhv_****  is median rank of high vs visualisation (x axis is
%           visualisation neighbour rank
% mvh_****  is the other way round.  X axis is hd neighbour rank, y is 
%           median rank in visualisation


[ qq_tspts_raw bb_tspts_raw crh_tspts_raw mhv_tspts_raw mvh_tspts_raw ]...
    = co_rank_criterion( zscores, tspts_raw ); 
[ qq_tspts_white bb_tspts_white crh_tspts_white mhv_tspts_white mvh_tspts_white ]...
    = co_rank_criterion( zscores, tspts_white ); 

[ qq_pc  bb_pc  crh_pc mhv_pc mvh_pc ]...
    = co_rank_criterion( zscores, pcproj(:,1:2) ); 

figure
plot( qq_tspts_raw, 'b');
hold on
plot( bb_tspts_raw, 'b');
plot( qq_tspts_white, 'g'); 
plot(bb_tspts_white, 'g'); 
plot( qq_pc, 'r'); 
plot( bb_pc, 'r');
hold off

figure
plot( mhv_tspts_raw, 'b');
hold on
plot( mvh_tspts_raw, 'k');
plot( mhv_tspts_white, 'g'); 
plot(mvh_tspts_white, 'c'); 
plot( mhv_pc, 'r'); 
plot( mvh_pc, 'm');
hold off


% neighbour_plots
figure; 
neighbour_plot( tspts_white, zscores );
hold on
plot( tspts_white(:,1), tspts_white(:,2), '.')
hold off


figure; 
neighbour_plot( tspts_raw, zscores );  % should be 'better'

figure;
neighbour_plot( 20 * pcproj(:,1:2), zscores ); 

% plotting the co-rank histograms
% need to bin them first because they are huge,so will not plot smoothly
% otherwise



%evaluate from here, 
%cq = cumsum2( crh_tspts_white ); 
%qbinned = decumulate2( cq( 19:20:end, 19:20:end) );
figure
logsurf = log10(crh_tspts_white(1:30, 1:30)); 
surf( logsurf )
xlabel( 'Zscore neighbour ranks' ); 
ylabel( 'Vis neighbour ranks');

maxheight= max( logsurf(:)); % to equalise colormaps

figure; surf( qbinned )
%%%%%%%%%%%%%%%%% to here

%evaluate from here, 
cq = cumsum2( crh_tspts_raw ); 
qbinned = decumulate2( cq( 19:20:end, 19:25:end) );

figure
surf( log10(qbinned +0.5))

figure; surf( qbinned )
clear cq qbinned
%%%%%%%%%%%%%%%%% to here


%evaluate from here, 
figure
logsurf = log10(crh_pc(1:30, 1:30)); 
surf( logsurf )
xlabel( 'Zscore neighbour ranks' ); 
ylabel( 'Vis neighbour ranks');


cq = cumsum2( crh_pc ); 
qbinned = decumulate2( cq( 19:20:end, 19:25:end) );

figure
surf( log10(qbinned +0.5))
hold on
surf( [0 1 ], [ 0 1 ], maxheight * ones( 2, 2)); 
hold off
figure; surf( qbinned )
clear cq qbinned
%%%%%%%%%%%%%%%%% to here

%%%%%%%%%%%%%% try just one graph
K = 15;
figure
surf( crh_tspts_white(1:K,1:K) ./ crh_pc(1:K,1:K) ); 

